<?php
/***********************************************************************

  Copyright (C) 2002-2007  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


define('PUN_ROOT', '../');
require PUN_ROOT.'include/common.php';
require PUN_ROOT.'include/common_admin.php';


if ($pun_user['g_id'] != PUN_ADMIN && ($pun_user['g_moderator'] != '1' || $pun_config['p_mod_ban_users'] == '0'))
	message($lang_common['No permission']);

// Load the admin.php language file
require PUN_ROOT.'lang/'.$pun_user['language'].'/admin.php';


// Add/edit a ban (stage 1)
if (isset($_REQUEST['add_ban']) || isset($_GET['edit_ban']))
{
	if (isset($_GET['add_ban']) || isset($_POST['add_ban']))
	{
		// If the id of the user to ban was provided through GET (a link from profile.php)
		if (isset($_GET['add_ban']))
		{
			$add_ban = intval($_GET['add_ban']);
			if ($add_ban < 2)
				message($lang_common['Bad request']);

			$user_id = $add_ban;

			$result = $db->query('SELECT group_id, username, email, registration_ip FROM '.$db->prefix.'users WHERE id='.$user_id) or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
			if ($db->num_rows($result))
				list($group_id, $ban_user, $ban_email, $ban_ip) = $db->fetch_row($result);
			else
				message($lang_admin['No user id message']);
		}
		else	// Otherwise the username is in POST
		{
			$ban_user = trim($_POST['new_ban_user']);

			if ($ban_user != '')
			{
				$result = $db->query('SELECT id, group_id, username, email, registration_ip FROM '.$db->prefix.'users WHERE username=\''.$db->escape($ban_user).'\' AND id>1') or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
				if ($db->num_rows($result))
					list($user_id, $group_id, $ban_user, $ban_email, $ban_ip) = $db->fetch_row($result);
				else
					message($lang_admin['No user username message']);
			}
		}

		// Make sure we're not banning an admin
		if (isset($group_id) && $group_id == PUN_ADMIN)
			message($lang_admin['User is admin message']);

		// If we have a $user_id, we can try to find the last known IP of that user
		if (isset($user_id))
		{
			$result = $db->query('SELECT poster_ip FROM '.$db->prefix.'posts WHERE poster_id='.$user_id.' ORDER BY posted DESC LIMIT 1') or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());
			$ban_ip = ($db->num_rows($result)) ? $db->result($result) : $ban_ip;
		}

		$mode = 'add';
	}
	else	// We are editing a ban
	{
		$ban_id = intval($_GET['edit_ban']);
		if ($ban_id < 1)
			message($lang_common['Bad request']);

		$result = $db->query('SELECT username, ip, email, message, expire FROM '.$db->prefix.'bans WHERE id='.$ban_id) or error('Unable to fetch ban info', __FILE__, __LINE__, $db->error());
		if ($db->num_rows($result))
			list($ban_user, $ban_ip, $ban_email, $ban_message, $ban_expire) = $db->fetch_row($result);
		else
			message($lang_common['Bad request']);

		// We just use GMT for expire dates, as its a date rather than a day I don't think its worth worrying about
		$ban_expire = ($ban_expire != '') ? gmdate('Y-m-d', $ban_expire) : '';

		$mode = 'edit';
	}


	// Setup breadcrumbs
	$pun_page['crumbs'] = array(
		array($pun_config['o_board_title'], pun_link($pun_url['index'])),
		array($lang_admin['Forum administration'], pun_link($pun_url['admin_index'])),
		array($lang_admin['Bans'], pun_link($pun_url['admin_bans'])),
		$lang_admin['Ban advanced heading']
	);

	define('PUN_PAGE_SECTION', 'users');
	define('PUN_PAGE', 'admin-bans');
	require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main a-admin">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

<?php echo generate_admin_menu(); ?>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['admin_bans']) ?>">
				<div class="panel">
					<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
					<div class="form-intro">
						<h2 class="prefix"><span><?php echo $lang_admin['Ban advanced heading'] ?>: </span></h2>
						<p><?php echo $lang_admin['Supplement ban info'] ?></p>
					</div>
					<fieldset class="textset">
						<input type="hidden" name="mode" value="<?php echo $mode ?>" />
<?php if ($mode == 'edit'): ?>				<input type="hidden" name="ban_id" value="<?php echo $ban_id ?>" />
<?php endif; ?>						<legend><span><?php echo $lang_admin['Ban criteria legend'] ?></span></legend>
						<p class="field">
							<label for="fs1f1"><?php echo $lang_admin['Username to ban'] ?></label><br />
							<span class="input"><input type="text" id="fs1f1" name="ban_user" size="25" maxlength="25" value="<?php if (isset($ban_user)) echo htmlspecialchars($ban_user); ?>" /> <em><?php echo $lang_admin['Case sensitive'] ?></em></span>
						</p>
						<p class="field">
							<label for="fs1f3"><?php echo $lang_admin['E-mail/domain to ban'] ?></label><br />
							<span class="input"><input type="text" id="fs1f3" name="ban_email" size="40" maxlength="80" value="<?php if (isset($ban_email)) echo strtolower($ban_email); ?>" /><br />	<em class="field-info"><?php echo $lang_admin['E-mail/domain info'] ?></em></span><br />
						</p>
						<p class="field">
							<label for="fs1f2"><?php echo $lang_admin['IP-addresses to ban'] ?></label><br />
							<span class="input"><input type="text" id="fs1f2" name="ban_ip" size="45" maxlength="255" value="<?php if (isset($ban_ip)) echo $ban_ip; ?>" /><br /> <em class="field-info"><?php echo $lang_admin['IP-addresses info']; if ($ban_user != '' && isset($user_id)) echo ' '.$lang_admin['IP-addresses info 2'].'<a href="'.pun_link($pun_url['admin_users']).'?ip_stats='.$user_id.'">'.$lang_admin['IP-addresses info link'].'</a>' ?></em></span><br />
						</p>
					</fieldset>
					<div class="form-warn">
						<p><strong><?php echo $lang_admin['Warning'] ?></strong> <?php echo $lang_admin['Ban IP warning'] ?></p>
					</div>
					<fieldset class="textset">
						<legend><span><?php echo $lang_admin['Ban settings legend'] ?></span></legend>
						<p class="field">
							<label for="fs1f4"><?php echo $lang_admin['Ban message'] ?></label><br />
							<span class="input"><input type="text" id="fs1f4" name="ban_message" size="50" maxlength="255" value="<?php if (isset($ban_message)) echo htmlspecialchars($ban_message); ?>" /><br /> <em class="field-info"><?php echo $lang_admin['Ban message info'] ?></em></span><br />
						</p>
						<p class="field">
							<label for="fs1f5"><?php echo $lang_admin['Expire date'] ?></label><br />
							<span class="input"><input type="text" id="fs1f5" name="ban_expire" size="17" maxlength="10" value="<?php if (isset($ban_expire)) echo $ban_expire; ?>" /><br /> <em class="field-info"><?php echo $lang_admin['Expire date info'] ?></em></span><br />
						</p>
					</fieldset>
					<p class="formsubmit"><input type="submit" class="button" name="add_edit_ban" value=" <?php echo $lang_admin['Save'] ?>" /></p>
				</div>
			</form>
		</div>
	</div>

</div>
<?php

	require PUN_ROOT.'footer.php';
}


// Add/edit a ban (stage 2)
else if (isset($_POST['add_edit_ban']))
{
	$ban_user = trim($_POST['ban_user']);
	$ban_ip = trim($_POST['ban_ip']);
	$ban_email = strtolower(trim($_POST['ban_email']));
	$ban_message = trim($_POST['ban_message']);
	$ban_expire = trim($_POST['ban_expire']);

	if ($ban_user == '' && $ban_ip == '' && $ban_email == '')
		message($lang_admin['Must enter message']);
	else if (strtolower($ban_user) == 'guest')
		message($lang_admin['Can\'t ban guest user']);

	// Validate IP/IP range (it's overkill, I know)
	if ($ban_ip != '')
	{
		$ban_ip = preg_replace('/[\s]{2,}/', ' ', $ban_ip);
		$addresses = explode(' ', $ban_ip);
		$addresses = array_map('trim', $addresses);

		for ($i = 0; $i < count($addresses); ++$i)
		{
			$octets = explode('.', $addresses[$i]);

			for ($c = 0; $c < count($octets); ++$c)
			{
				$octets[$c] = (strlen($octets[$c]) > 1) ? ltrim($octets[$c], "0") : $octets[$c];

				if ($c > 3 || !ctype_digit($octets[$c]) || intval($octets[$c]) > 255)
					message($lang_admin['Invalid IP message']);
			}

			$cur_address = implode('.', $octets);
			$addresses[$i] = $cur_address;
		}

		$ban_ip = implode(' ', $addresses);
	}

	require PUN_ROOT.'include/email.php';
	if ($ban_email != '' && !is_valid_email($ban_email))
	{
		if (!preg_match('/^[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,4})$/', $ban_email))
			message($lang_admin['Invalid e-mail message']);
	}

	if ($ban_expire != '' && $ban_expire != 'Never')
	{
		$ban_expire = strtotime($ban_expire);

		if ($ban_expire == -1 || $ban_expire <= time())
			message($lang_admin['Invalid expire message']);
	}
	else
		$ban_expire = 'NULL';

	$ban_user = ($ban_user != '') ? '\''.$db->escape($ban_user).'\'' : 'NULL';
	$ban_ip = ($ban_ip != '') ? '\''.$db->escape($ban_ip).'\'' : 'NULL';
	$ban_email = ($ban_email != '') ? '\''.$db->escape($ban_email).'\'' : 'NULL';
	$ban_message = ($ban_message != '') ? '\''.$db->escape($ban_message).'\'' : 'NULL';

	if ($_POST['mode'] == 'add')
		$db->query('INSERT INTO '.$db->prefix.'bans (username, ip, email, message, expire, ban_creator) VALUES('.$ban_user.', '.$ban_ip.', '.$ban_email.', '.$ban_message.', '.$ban_expire.', '.$pun_user['id'].')') or error('Unable to add ban', __FILE__, __LINE__, $db->error());
	else
		$db->query('UPDATE '.$db->prefix.'bans SET username='.$ban_user.', ip='.$ban_ip.', email='.$ban_email.', message='.$ban_message.', expire='.$ban_expire.' WHERE id='.intval($_POST['ban_id'])) or error('Unable to update ban', __FILE__, __LINE__, $db->error());

	// Regenerate the bans cache
	require_once PUN_ROOT.'include/cache.php';
	generate_bans_cache();

	redirect(pun_link($pun_url['admin_bans']), (($_POST['mode'] == 'edit') ? $lang_admin['Ban edited'] : $lang_admin['Ban added']).' '.$lang_admin['Redirect']);
}


// Remove a ban
else if (isset($_GET['del_ban']))
{
	$ban_id = intval($_GET['del_ban']);
	if ($ban_id < 1)
		message($lang_common['Bad request']);

	$db->query('DELETE FROM '.$db->prefix.'bans WHERE id='.$ban_id) or error('Unable to delete ban', __FILE__, __LINE__, $db->error());

	// Regenerate the bans cache
	require_once PUN_ROOT.'include/cache.php';
	generate_bans_cache();

	redirect(pun_link($pun_url['admin_bans']), $lang_admin['Ban removed'].' '. $lang_admin['Redirect']);
}


// Setup breadcrumbs
$pun_page['crumbs'] = array(
	array($pun_config['o_board_title'], pun_link($pun_url['index'])),
	array($lang_admin['Forum administration'], pun_link($pun_url['admin_index'])),
	$lang_admin['Bans']
);

define('PUN_PAGE_SECTION', 'users');
define('PUN_PAGE', 'admin-bans');
require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main a-admin">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

<?php echo generate_admin_menu(); ?>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form class="pun-adcontent" method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['admin_bans']) ?>?action=more">
			<div class="panel">
				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
				<div class="form-intro">
					<h2 class="prefix"><span><?php echo $lang_admin['New ban heading'] ?>: </span></h2>
					<p><?php echo $lang_admin['Add username info'] ?></p>
				</div>
				<div class="textset" id="fs1">
					<p class="field">
						<label for="fs1f1"><?php echo $lang_admin['Username to ban'] ?></label><br />
						<span class="input"><input type="text" id="fs1f1" name="new_ban_user" size="25" maxlength="25" /> <em><?php echo $lang_admin['Case sensitive'] ?></em></span>
					</p>
				</div>
				<p class="formsubmit"><input type="submit" class="button" name="add_ban" value=" Add " /></p>
			</div>
			</form>
			<div class="divider"><hr /></div>
			<div class="panel">
				<div class="form-intro">
					<h2 class="prefix"><span><?php echo $lang_admin['Existing bans heading'] ?>: </span></h2>
					<p><?php echo $lang_admin['Existing bans info'] ?></p>
				</div>
<?php

if (!empty($pun_bans))
{
	foreach ($pun_bans as $ban_key => $cur_ban)
	{
		$expire = format_time($cur_ban['expire'], true);

		if ($ban_key > 0)
			echo "\t\t\t\t".'<div class="divider"><hr /></div>'."\n";

?>
				<div class="textset" id="fs<?php echo ($ban_key + 2) ?>">
<?php if ($cur_ban['username'] != ''): ?>					<p class="field">
						<strong class="alabel"><?php echo $lang_admin['Username'] ?></strong>
						<span class="input"><?php echo htmlspecialchars($cur_ban['username']) ?></span>
					</p>
<?php endif; if ($cur_ban['email'] != ''): ?>					<p class="field">
						<strong class="alabel"><?php echo $lang_admin['E-mail'] ?></strong>
						<span class="input"><?php echo $cur_ban['email'] ?></span>
					</p>
<?php endif; if ($cur_ban['ip'] != ''): ?>					<p class="field">
						<strong class="alabel"><?php echo $lang_admin['IP-ranges'] ?></strong>
						<span class="input"><?php echo $cur_ban['ip'] ?></span>
					</p>
<?php endif; if ($cur_ban['ban_creator_username'] != ''): ?>					<p class="field">
						<strong class="alabel"><?php echo $lang_admin['Ban creator'] ?></strong>
						<span class="input"><a href="<?php echo pun_link($pun_url['user'], $cur_ban['ban_creator']) ?>"><?php echo htmlspecialchars($cur_ban['ban_creator_username']) ?></a></span>
					</p>
<?php endif; if ($cur_ban['message'] != ''): ?>					<p class="field">
						<strong class="alabel"><?php echo $lang_admin['Reason'] ?></strong>
						<span class="input"><?php echo htmlspecialchars($cur_ban['message']) ?></span>
					</p>
<?php endif; ?>					<p class="field">
						<strong class="alabel"><a href="<?php echo pun_link($pun_url['admin_bans']) ?>?edit_ban=<?php echo $cur_ban['id'] ?>"><?php echo $lang_admin['Edit'] ?></a> <a href="<?php echo pun_link($pun_url['admin_bans']) ?>?del_ban=<?php echo $cur_ban['id'] ?>"><?php echo $lang_admin['Remove'] ?></a></strong>
						<span class="input"><?php echo $lang_admin['Expires'].': '.$expire ?></span>
					</p>
				</div>
<?php

	}
}
else
	echo "\t\t\t\t".'<p>'.$lang_admin['No bans'].'</p>'."\n";

?>
			</div>
		</div>
	</div>

</div>
<?php

require PUN_ROOT.'footer.php';
