<?php
/***********************************************************************

  Copyright (C) 2002-2007  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


define('PUN_ROOT', '../');
require PUN_ROOT.'include/common.php';
require PUN_ROOT.'include/common_admin.php';


if (!$pun_user['is_admmod'])
	message($lang_common['No permission']);

// Load the admin.php language file
require PUN_ROOT.'lang/'.$pun_user['language'].'/admin.php';


// Show IP statistics for a certain user ID
if (isset($_GET['ip_stats']))
{
	$ip_stats = intval($_GET['ip_stats']);
	if ($ip_stats < 1)
		message($lang_common['Bad request']);

	// Setup breadcrumbs
	$pun_page['crumbs'] = array(
		array($pun_config['o_board_title'], pun_link($pun_url['index'])),
		array($lang_admin['Forum administration'], pun_link($pun_url['admin_index'])),
		array($lang_admin['Searches'], pun_link($pun_url['admin_users'])),
		$lang_admin['User search results']
	);

	define('PUN_PAGE_SECTION', 'users');
	define('PUN_PAGE', 'admin-users');
	require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main a-admin">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

<?php echo generate_admin_menu(); ?>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<div class="panel">
				<div class="form-intro">
					<h3><span><?php echo end($pun_page['crumbs']) ?></span></h3>
				</div>
			<table cellspacing="0">
			<thead>
				<tr>
					<th class="tcl" scope="col"><?php echo $lang_admin['IP address'] ?></th>
					<th class="tc2" scope="col"><?php echo $lang_admin['Last used'] ?></th>
					<th class="tc3" scope="col"><?php echo $lang_admin['Times found'] ?></th>
					<th class="tcr" scope="col"><?php echo $lang_admin['Actions'] ?></th>
				</tr>
			</thead>
			<tbody>
<?php

	$result = $db->query('SELECT poster_ip, MAX(posted) AS last_used, COUNT(id) AS used_times FROM '.$db->prefix.'posts WHERE poster_id='.$ip_stats.' GROUP BY poster_ip ORDER BY last_used DESC') or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());
	if ($db->num_rows($result))
	{
		while ($cur_ip = $db->fetch_assoc($result))
		{

?>
				<tr>
					<td class="tcl"><a href="<?php echo pun_link($pun_url['moderate']) ?>?get_host=<?php echo $cur_ip['poster_ip'] ?>"><?php echo $cur_ip['poster_ip'] ?></a></td>
					<td class="tc2"><?php echo format_time($cur_ip['last_used']) ?></td>
					<td class="tc3"><?php echo $cur_ip['used_times'] ?></td>
					<td class="tcr"><a href="<?php echo pun_link($pun_url['admin_users']) ?>?show_users=<?php echo $cur_ip['poster_ip'] ?>"><?php echo $lang_admin['Find more users'] ?></a></td>
				</tr>
<?php

		}
	}
	else
		echo "\t\t\t\t\t\t".'<tr><td class="tcl" colspan="4">'.$lang_admin['No posts by user'].'</td></tr>'."\n";

?>
			</tbody>
			</table>
			</div>
		</div>
	</div>

</div>
<?php

	require PUN_ROOT.'footer.php';
}


else if (isset($_GET['show_users']))
{
	$ip = $_GET['show_users'];

	if (!@preg_match('/[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/', $ip))
		message('The supplied IP address is not correctly formatted.');

	// Load the misc.php language file
	require PUN_ROOT.'lang/'.$pun_user['language'].'/misc.php';

	// Setup breadcrumbs
	$pun_page['crumbs'] = array(
		array($pun_config['o_board_title'], pun_link($pun_url['index'])),
		array($lang_admin['Forum administration'], pun_link($pun_url['admin_index'])),
		array($lang_admin['Searches'], pun_link($pun_url['admin_users'])),
		$lang_admin['User search results']
	);

	define('PUN_PAGE_SECTION', 'users');
	define('PUN_PAGE', 'admin-users');
	require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main a-admin">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

<?php echo generate_admin_menu(); ?>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['admin_users']) ?>?action=modify_users">
			<div class="panel">
			<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
			<table cellspacing="0">
			<thead>
				<tr>
					<th class="tcl" scope="col"><?php echo $lang_admin['Username column'] ?></th>
					<th class="tc2" scope="col"><?php echo $lang_admin['Title column'] ?></th>
					<th class="tc3" scope="col"><?php echo $lang_admin['Posts'] ?></th>
					<th class="tcr" scope="col"><?php echo $lang_admin['Actions'] ?></th>
					<?php if ($pun_user['g_id'] == PUN_ADMIN): ?><th class="tcmod" scope="col"><?php echo $lang_misc['Select'] ?></th><?php endif; ?>
				</tr>
			</thead>
			<tbody>
<?php

	$result = $db->query('SELECT DISTINCT poster_id, poster FROM '.$db->prefix.'posts WHERE poster_ip=\''.$db->escape($ip).'\' ORDER BY poster DESC') or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());
	$num_posts = $db->num_rows($result);

	if ($num_posts)
	{
		// Loop through users and print out some info
		for ($i = 0; $i < $num_posts; ++$i)
		{
			list($poster_id, $poster) = $db->fetch_row($result);

			$result2 = $db->query('SELECT u.id, u.username, u.email, u.title, u.num_posts, u.admin_note, g.g_id, g.g_user_title FROM '.$db->prefix.'users AS u INNER JOIN '.$db->prefix.'groups AS g ON g.g_id=u.group_id WHERE u.id>1 AND u.id='.$poster_id) or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());

			if (($user_data = $db->fetch_assoc($result2)))
			{
				$user_title = get_title($user_data);

				$actions = '<a href="'.pun_link($pun_url['admin_users']).'?ip_stats='.$user_data['id'].'">'.$lang_admin['View IP stats'].'</a> - <a href="'.pun_link($pun_url['search_user'], $user_data['id']).'">'.$lang_admin['Show posts'].'</a>';

?>
				<tr>
					<td class="tcl"><?php echo '<strong><a href="'.pun_link($pun_url['user'], $user_data['id']).'">'.htmlspecialchars($user_data['username']).'</a></strong>' ?> - <span class="usermail"><a href="mailto:<?php echo $user_data['email'] ?>"><?php echo $user_data['email'] ?></a></span><?php if ($user_data['admin_note'] != '') echo '<span class="usernote">'.htmlspecialchars($user_data['admin_note']).'</span>' ?></td>
					<td class="tc2"><?php echo $user_title ?></td>
					<td class="tc3"><?php echo $user_data['num_posts'] ?></td>
					<td class="tcr"><?php echo $actions ?></td>
					<?php if ($pun_user['g_id'] == PUN_ADMIN): ?><td class="tcmod"><input type="checkbox" name="users[<?php echo $user_data['id'] ?>]" value="1" /></td><?php endif; ?>
				</tr>
<?php

			}
			else
			{

?>
				<tr>
					<td class="tcl"><?php echo htmlspecialchars($poster) ?></td>
					<td class="tc2"><?php echo $cur_ip['poster_ip'].' '.$lang_admin['Guest'] ?></td>
					<td class="tc3">&#160;</td>
					<td class="tcr">&#160;</td>
					<?php if ($pun_user['g_id'] == PUN_ADMIN): ?><td class="tcmod">&#160;</td><?php endif; ?>
				</tr>
<?php

			}
		}
	}
	else
		echo "\t\t\t\t\t".'<tr><td class="tcl" colspan="'.(($pun_user['g_id'] == PUN_ADMIN) ? '5' : '4').'">'.$lang_admin['Cannot find IP'].'</td></tr>'."\n";

?>
			</tbody>
			</table>
			</div>
		</div>
	</div>
	<div class="b-section b-mainoptions">
		<div class="c-section c-any">
			<h2><span><?php echo $lang_admin['Moderate users'] ?></span></h2>
			<ul class="optionlist">
				<li id="mo-ban" class="mo-button"><input type="submit" class="button" name="ban_users" value="<?php echo $lang_admin['Ban'] ?>" /></li>
				<li id="mo-delete" class="mo-button"><input type="submit" class="button" name="delete_users" value="<?php echo $lang_admin['Delete'] ?>" /></li>
				<li id="mo-change-group" class="mo-button"><input type="submit" class="button" name="change_group" value="<?php echo $lang_admin['Change group'] ?>" /></li>
			</ul>
		</div>
	</div>
	</form>

</div>
<?php

	require PUN_ROOT.'footer.php';
}


else if (isset($_POST['delete_users']) || isset($_POST['delete_users_comply']) || isset($_POST['delete_users_cancel']))
{
	// User pressed the cancel button
	if (isset($_POST['delete_users_cancel']))
		redirect(pun_link($pun_url['admin_users']), $lang_common['Cancel redirect']);

	if ($pun_user['g_id'] != PUN_ADMIN)
		message($lang_common['No permission']);

	if (!is_array($_POST['users']))
		$users = explode(',', $_POST['users']);
	else
		$users = array_keys($_POST['users']);

	$users = array_map('intval', $users);

	// We check to make sure there are no administrators in this list
	$result = $db->query('SELECT 1 FROM '.$db->prefix.'users WHERE id IN ('.implode(',', $users).') AND group_id='.PUN_ADMIN) or error('Unable to check users', __FILE__, __LINE__, $db->error());
	if ($db->num_rows($result) > 0)
		message($lang_admin['Delete admin message']);

	if (isset($_POST['delete_users_comply']))
	{
		foreach ($users as $id)
		{
			// We don't want to delete the Guest user
			if ($id > 1)
				delete_user($id, true);
		}

		redirect(pun_link($pun_url['admin_users']), $lang_admin['Users deleted'].' '.$lang_admin['Redirect']);
	}


	// Setup breadcrumbs
	$pun_page['crumbs'] = array(
		array($pun_config['o_board_title'], pun_link($pun_url['index'])),
		array($lang_admin['Forum administration'], pun_link($pun_url['admin_index'])),
		array($lang_admin['Searches'], pun_link($pun_url['admin_users'])),
		$lang_admin['Delete users']
	);

	define('PUN_PAGE', 'dialogue');
	require PUN_ROOT.'header.php';

	$fld_count = 0;

?>
<div id="pun-main1" class="a-section a-main">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['admin_users']) ?>?action=modify_users">
			<div class="panel">
				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
				<input type="hidden" name="users" value="<?php echo implode(',', $users) ?>" />
				<div class="textset">
					<p class="field">
						<strong class="alabel"><?php echo $lang_admin['Delete posts legend'] ?></strong><br />
						<span class="input"><input type="checkbox" id="fld<?php echo ++$fld_count ?>" name="delete_posts" value="1" checked="checked" /> <label for="fld<?php echo $fld_count ?>"><?php echo $lang_admin['Delete posts label'] ?></label></span>
					</p>
				</div>
				<div class="form-warn">
					<p><strong><?php echo $lang_common['Warning'] ?></strong> <?php echo $lang_admin['Delete warning'] ?></p>
				</div>
				<p class="formsubmit"><input type="submit" class="button" name="delete_users_comply" value="<?php echo $lang_admin['Delete'] ?>" /> <input type="submit" class="button" name="delete_users_cancel" value="<?php echo $lang_common['Cancel'] ?>" /></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php

	require PUN_ROOT.'footer.php';
}


else if (isset($_POST['ban_users']) || isset($_POST['ban_users_comply']))
{
	if ($pun_user['g_id'] != PUN_ADMIN)
		message($lang_common['No permission']);

	if (!is_array($_POST['users']))
		$users = explode(',', $_POST['users']);
	else
		$users = array_keys($_POST['users']);

	$users = array_map('intval', $users);

	// We check to make sure there are no administrators in this list
	$result = $db->query('SELECT 1 FROM '.$db->prefix.'users WHERE id IN ('.implode(',', $users).') AND group_id='.PUN_ADMIN) or error('Unable to check users', __FILE__, __LINE__, $db->error());
	if ($db->num_rows($result) > 0)
		message($lang_admin['Ban admin message']);

	if (isset($_POST['ban_users_comply']))
	{
		$ban_message = trim($_POST['ban_message']);
		$ban_expire = trim($_POST['ban_expire']);

		if ($ban_expire != '' && $ban_expire != 'Never')
		{
			$ban_expire = strtotime($ban_expire);

			if ($ban_expire == -1 || $ban_expire <= time())
				message($lang_admin['Invalid expire message']);
		}
		else
			$ban_expire = 'NULL';

		$ban_message = ($ban_message != '') ? '"'.$db->escape($ban_message).'"' : 'NULL';

		// Get the latest IPs for the posters and store them for a little later
		$result = $db->query('SELECT poster_id, poster_ip FROM '.$db->prefix.'posts WHERE poster_id IN ('.implode(',', $users).') AND poster_id>1 GROUP BY poster_id ORDER BY posted DESC');
		$ips = array();
		while ($cur_post = $db->fetch_assoc($result))
		{
			$ips[$cur_post['poster_id']] = $cur_post['poster_ip'];
		}

		// Get the rest of the data for the posters, merge in the IP information, create a ban
		$result = $db->query('SELECT id, username, email, registration_ip FROM '.$db->prefix.'users WHERE id IN ('.implode(',', $users).') AND id>1') or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
		while ($cur_user = $db->fetch_assoc($result))
		{
			$ban_ip = isset($ips[$cur_user['id']]) ? $ips[$cur_user['id']] : $cur_user['registration_ip'];

			$db->query('INSERT INTO '.$db->prefix.'bans (username, ip, email, message, expire, ban_creator) VALUES("'.$db->escape($cur_user['username']).'", "'.$ban_ip.'", "'.$db->escape($cur_user['email']).'", '.$ban_message.', '.$ban_expire.', '.$pun_user['id'].')') or error('Unable to add ban', __FILE__, __LINE__, $db->error());
		}

		// Regenerate the bans cache
		require_once PUN_ROOT.'include/cache.php';
		generate_bans_cache();

		redirect(pun_link($pun_url['admin_users']), $lang_admin['Users banned'].' '.$lang_admin['Redirect']);
	}


	// Setup breadcrumbs
	$pun_page['crumbs'] = array(
		array($pun_config['o_board_title'], pun_link($pun_url['index'])),
		array($lang_admin['Forum administration'], pun_link($pun_url['admin_index'])),
		array($lang_admin['Searches'], pun_link($pun_url['admin_users'])),
		$lang_admin['Ban users']
	);

	define('PUN_PAGE_SECTION', 'users');
	define('PUN_PAGE', 'admin-bans');
	require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main a-admin">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

<?php echo generate_admin_menu(); ?>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['admin_users']) ?>?action=modify_users">
				<div class="panel">
					<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
					<input type="hidden" name="users" value="<?php echo implode(',', $users) ?>" />
					<div class="form-intro">
						<h2 class="prefix"><span><?php echo $lang_admin['Ban advanced heading'] ?>: </span></h2>
						<p><?php echo $lang_admin['Mass ban info'] ?></p>
					</div>
					<fieldset class="textset">
						<legend><span><?php echo $lang_admin['Ban settings legend'] ?></span></legend>
						<p class="field">
							<label for="fs1f4"><?php echo $lang_admin['Ban message'] ?></label><br />
							<span class="input"><input type="text" id="fs1f1" name="ban_message" size="50" maxlength="255" /><br /> <em class="field-info"><?php echo $lang_admin['Ban message info'] ?></em></span><br />
						</p>
						<p class="field">
							<label for="fs1f5"><?php echo $lang_admin['Expire date'] ?></label><br />
							<span class="input"><input type="text" id="fs1f2" name="ban_expire" size="17" maxlength="10" /><br /> <em class="field-info"><?php echo $lang_admin['Expire date info'] ?></em></span><br />
						</p>
					</fieldset>
					<p class="formsubmit"><input type="submit" class="button" name="ban_users_comply" value="<?php echo $lang_admin['Ban'] ?>" /></p>
				</div>
			</form>
		</div>
	</div>

</div>
<?php

	require PUN_ROOT.'footer.php';
}


else if (isset($_POST['change_group']) || isset($_POST['change_group_comply']) || isset($_POST['change_group_cancel']))
{
	if ($pun_user['g_id'] != PUN_ADMIN)
		message($lang_common['No permission']);

	// User pressed the cancel button
	if (isset($_POST['change_group_cancel']))
		redirect(pun_link($pun_url['admin_users']), $lang_admin['Cancel redirect']);

	if (!is_array($_POST['users']))
		$users = explode(',', $_POST['users']);
	else
		$users = array_keys($_POST['users']);

	$users = array_map('intval', $users);

	if (isset($_POST['change_group_comply']))
	{
		$move_to_group = intval($_POST['move_to_group']);

		// We need some information on the group
		$result = $db->query('SELECT g_moderator FROM '.$db->prefix.'groups WHERE g_id='.$move_to_group) or error('Unable to fetch group info', __FILE__, __LINE__, $db->error());

		if ($move_to_group == PUN_GUEST || $db->num_rows($result) < 1)
			message($lang_common['Bad request']);

		$is_admmod = ($move_to_group == PUN_ADMIN || $db->result($result) == '1');

		// If we're moving to a non admin/mod group, We see which users may need to be removed
		// from the moderator list
		if (!$is_admmod)
		{
			$result = $db->query('SELECT u.username, g.g_id, g.g_moderator FROM '.$db->prefix.'users AS u INNER JOIN '.$db->prefix.'groups AS g ON (g.g_id=u.group_id) WHERE u.id IN ('.implode(',', $users).')') or error('Unable to fetch user information', __FILE__, __LINE__, $db->error());
			$to_remove = array();
			while ($cur_user = $db->fetch_assoc($result))
			{
				// If the user was an admin/mod, we need to remove them from the moderator list
				if ($cur_user['g_id'] == PUN_ADMIN || $cur_user['g_moderator'] == '1')
					$to_remove[] = $cur_user['username'];
			}

			// If there are users to remove, we do it
			if (!empty($to_remove))
			{
				// Loop through all forums
				$result = $db->query('SELECT id, moderators FROM '.$db->prefix.'forums') or error('Unable to fetch forum list', __FILE__, __LINE__, $db->error());

				while ($cur_forum = $db->fetch_assoc($result))
				{
					$cur_moderators = ($cur_forum['moderators'] != '') ? unserialize($cur_forum['moderators']) : array();

					foreach ($to_remove as $username)
					{
						unset($cur_moderators[$username]);
					}

					$cur_moderators = (!empty($cur_moderators)) ? '\''.$db->escape(serialize($cur_moderators)).'\'' : 'NULL';

					$db->query('UPDATE '.$db->prefix.'forums SET moderators='.$cur_moderators.' WHERE id='.$cur_forum['id']) or error('Unable to update forum', __FILE__, __LINE__, $db->error());
				}
			}
		}

		// Move users
		$db->query('UPDATE '.$db->prefix.'users SET group_id='.$move_to_group.' WHERE id IN ('.implode(',', $users).') AND id>1') or error('Unable to move users into group', __FILE__, __LINE__, $db->error());

		redirect(pun_link($pun_url['admin_users']), $lang_admin['User groups updated'].' '.$lang_admin['Redirect']);
	}


	// Setup breadcrumbs
	$pun_page['crumbs'] = array(
		array($pun_config['o_board_title'], pun_link($pun_url['index'])),
		array($lang_admin['Forum administration'], pun_link($pun_url['admin_index'])),
		array($lang_admin['Searches'], pun_link($pun_url['admin_users'])),
		$lang_admin['Change group']
	);

	define('PUN_PAGE_SECTION', 'users');
	define('PUN_PAGE', 'admin-bans');
	require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main a-admin">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

<?php echo generate_admin_menu(); ?>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['admin_users']) ?>?action=modify_users">
			<div class="panel">
				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
				<input type="hidden" name="users" value="<?php echo implode(',', $users) ?>" />
				<div class="form-intro">
					<h2 class="prefix"><span><?php echo end($pun_page['crumbs']) ?>: </span></h2>
					<p><?php echo $lang_admin['Change group intro'] ?></p>
				</div>
				<div class="textset" id="fs1">
					<p class="field">
						<label for="fs1f1"><?php echo $lang_admin['Move users to'] ?></label><br />
						<span class="input"><select id="fs1f1" name="move_to_group">
<?php

	$result = $db->query('SELECT g_id, g_title FROM '.$db->prefix.'groups WHERE g_id!='.PUN_GUEST.' ORDER BY g_title') or error('Unable to fetch user group list', __FILE__, __LINE__, $db->error());

	while ($cur_group = $db->fetch_assoc($result))
	{
		if ($cur_group['g_id'] == PUN_MEMBER)	// Pre-select the pre-defined Members group
			echo "\t\t\t\t\t\t\t\t".'<option value="'.$cur_group['g_id'].'" selected="selected">'.htmlspecialchars($cur_group['g_title']).'</option>'."\n";
		else
			echo "\t\t\t\t\t\t\t\t".'<option value="'.$cur_group['g_id'].'">'.htmlspecialchars($cur_group['g_title']).'</option>'."\n";
	}

?>
						</select></span>
					</p>
				</div>
				<p class="formsubmit"><input type="submit" class="button" name="change_group_comply" value="<?php echo $lang_admin['Change group'] ?>" /> <input type="submit" class="button" name="change_group_cancel" value="<?php echo $lang_admin['Cancel'] ?>" /></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php

	require PUN_ROOT.'footer.php';
}


else if (isset($_POST['find_user']))
{
	$form = $_POST['form'];
	$form['username'] = $_POST['username'];

	// trim() all elements in $form
	$form = array_map('trim', $form);
	$conditions = array();

	$posts_greater = trim($_POST['posts_greater']);
	$posts_less = trim($_POST['posts_less']);
	$last_post_after = trim($_POST['last_post_after']);
	$last_post_before = trim($_POST['last_post_before']);
	$registered_after = trim($_POST['registered_after']);
	$registered_before = trim($_POST['registered_before']);
	$order_by = $_POST['order_by'];
	$direction = $_POST['direction'];
	$user_group = $_POST['user_group'];

	if ((!empty($posts_greater) || !empty($posts_less)) && !ctype_digit($posts_greater.$posts_less))
		message($lang_admin['Non numeric value message']);

	// Try to convert date/time to timestamps
	if ($last_post_after != '')
		$last_post_after = strtotime($last_post_after);
	if ($last_post_before != '')
		$last_post_before = strtotime($last_post_before);
	if ($registered_after != '')
		$registered_after = strtotime($registered_after);
	if ($registered_before != '')
		$registered_before = strtotime($registered_before);

	if ($last_post_after == -1 || $last_post_before == -1 || $registered_after == -1 || $registered_before == -1)
		message($lang_admin['Invalid date/time message']);

	if ($last_post_after != '')
		$conditions[] = 'u.last_post>'.$last_post_after;
	if ($last_post_before != '')
		$conditions[] = 'u.last_post<'.$last_post_before;
	if ($registered_after != '')
		$conditions[] = 'u.registered>'.$registered_after;
	if ($registered_before != '')
		$conditions[] = 'u.registered<'.$registered_before;

	$like_command = ($db_type == 'pgsql') ? 'ILIKE' : 'LIKE';
	while (list($key, $input) = @each($form))
	{
		if ($input != '' && in_array($key, array('username', 'email', 'title', 'realname', 'url', 'jabber', 'icq', 'msn', 'aim', 'yahoo', 'location', 'signature', 'admin_note')))
			$conditions[] = 'u.'.$db->escape($key).' '.$like_command.' \''.$db->escape(str_replace('*', '%', $input)).'\'';
	}

	if ($posts_greater != '')
		$conditions[] = 'u.num_posts>'.$posts_greater;
	if ($posts_less != '')
		$conditions[] = 'u.num_posts<'.$posts_less;

	if ($user_group != 'all')
		$conditions[] = 'u.group_id='.intval($user_group);

	if (empty($conditions))
		message($lang_admin['No search terms message']);


	// Load the misc.php language file
	require PUN_ROOT.'lang/'.$pun_user['language'].'/misc.php';

	// Setup breadcrumbs
	$pun_page['crumbs'] = array(
		array($pun_config['o_board_title'], pun_link($pun_url['index'])),
		array($lang_admin['Forum administration'], pun_link($pun_url['admin_index'])),
		array($lang_admin['Searches'], pun_link($pun_url['admin_users'])),
		$lang_admin['User search results']
	);

	define('PUN_PAGE_SECTION', 'users');
	define('PUN_PAGE', 'admin-users');
	require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main a-admin">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

<?php echo generate_admin_menu(); ?>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['admin_users']) ?>?action=modify_users">
			<div class="panel">
			<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
			<table cellspacing="0">
			<thead>
				<tr>
					<th class="tcl" scope="col"><?php echo $lang_admin['Username column'] ?></th>
					<th class="tc2" scope="col"><?php echo $lang_admin['Title column'] ?></th>
					<th class="tc3" scope="col"><?php echo $lang_admin['Posts'] ?></th>
					<th class="tcr" scope="col"><?php echo $lang_admin['Actions'] ?></th>
					<?php if ($pun_user['g_id'] == PUN_ADMIN): ?><th class="tcmod" scope="col"><?php echo $lang_misc['Select'] ?></th><?php endif; ?>
				</tr>
			</thead>
			<tbody>
<?php

	$result = $db->query('SELECT u.id, u.username, u.email, u.title, u.num_posts, u.admin_note, g.g_id, g.g_user_title FROM '.$db->prefix.'users AS u LEFT JOIN '.$db->prefix.'groups AS g ON g.g_id=u.group_id WHERE u.id>1 AND '.implode(' AND ', $conditions).' ORDER BY '.$db->escape($order_by).' '.$db->escape($direction)) or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
	if ($db->num_rows($result))
	{
		while ($user_data = $db->fetch_assoc($result))
		{
			$user_title = get_title($user_data);

			// This script is a special case in that we want to display "Not verified" for non-verified users
			if (($user_data['g_id'] == '' || $user_data['g_id'] == PUN_UNVERIFIED) && $user_title != $lang_common['Banned'])
				$user_title = '<strong>'.$lang_admin['Not verified'].'</strong>';

			$actions = '<a href="'.pun_link($pun_url['admin_users']).'?ip_stats='.$user_data['id'].'">'.$lang_admin['View IP stats'].'</a> - <a href="'.pun_link($pun_url['search_user'], $user_data['id']).'">'.$lang_admin['Show posts'].'</a>';

?>
				<tr>
					<td class="tcl"><?php echo '<strong><a href="'.pun_link($pun_url['user'], $user_data['id']).'">'.htmlspecialchars($user_data['username']).'</a></strong>' ?> - <span class="usermail"><a href="mailto:<?php echo $user_data['email'] ?>"><?php echo $user_data['email'] ?></a></span><?php if ($user_data['admin_note'] != '') echo '<span class="usernote">'.htmlspecialchars($user_data['admin_note']).'</span>' ?></td>
					<td class="tc2"><?php echo $user_title ?></td>
					<td class="tc3"><?php echo $user_data['num_posts'] ?></td>
					<td class="tcr"><?php echo $actions ?></td>
					<?php if ($pun_user['g_id'] == PUN_ADMIN): ?><td class="tcmod"><input type="checkbox" name="users[<?php echo $user_data['id'] ?>]" value="1" /></td><?php endif; ?>
				</tr>
<?php

		}
	}
	else
		echo "\t\t\t\t\t".'<tr><td class="tcl" colspan="'.(($pun_user['g_id'] == PUN_ADMIN) ? '5' : '4').'">'.$lang_admin['No match'].'</td></tr>'."\n";

?>
			</tbody>
			</table>
			</div>
		</div>
	</div>
	<div class="b-section b-mainoptions">
		<div class="c-section c-any">
			<h2><span><?php echo $lang_admin['Moderate users'] ?></span></h2>
			<ul class="optionlist">
				<li id="mo-ban" class="mo-button"><input type="submit" class="button" name="ban_users" value="<?php echo $lang_admin['Ban'] ?>" /></li>
				<li id="mo-delete" class="mo-button"><input type="submit" class="button" name="delete_users" value="<?php echo $lang_admin['Delete'] ?>" /></li>
				<li id="mo-change-group" class="mo-button"><input type="submit" class="button" name="change_group" value="<?php echo $lang_admin['Change group'] ?>" /></li>
			</ul>
		</div>
	</div>
	</form>
</div>
<?php

	require PUN_ROOT.'footer.php';
}


else
{
	// Setup breadcrumbs
	$pun_page['crumbs'] = array(
		array($pun_config['o_board_title'], pun_link($pun_url['index'])),
		array($lang_admin['Forum administration'], pun_link($pun_url['admin_index'])),
		$lang_admin['Searches']
	);

	define('PUN_PAGE_SECTION', 'users');
	define('PUN_PAGE', 'admin-users');
	require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main a-admin">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

<?php echo generate_admin_menu(); ?>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['admin_users']) ?>?action=find_user">
			<div class="panel">
				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
				<div class="form-intro">
					<h2 class="prefix"><span><?php echo $lang_admin['User search head'] ?>: </span></h2>
					<p><?php echo $lang_admin['User search intro'] ?></p>
				</div>
				<fieldset class="textset" id="fs1">
					<legend><span><?php echo $lang_admin['User search legend'] ?></span></legend>
					<p class="field">
						<label for="fs1f1"><?php echo $lang_admin['Username'] ?></label><br />
						<span class="input"><input type="text" id="fs1f1" name="username" size="25" maxlength="25" /></span>
					</p>
					<p class="field">
						<label for="fs1f2"><?php echo $lang_admin['E-mail address'] ?></label><br />
						<span class="input"><input type="text" id="fs1f2" name="form[email]" size="30" maxlength="80" /></span>
					</p>
					<p class="field">
						<label for="fs1f3"><?php echo $lang_admin['Title'] ?></label><br />
						<span class="input"><input type="text" id="fs1f3" name="form[title]" size="30" maxlength="50" /></span>
					</p>
					<p class="field">
						<label for="fs1f4"><?php echo $lang_admin['Real name'] ?></label><br />
						<span class="input"><input type="text" id="fs1f4" name="form[realname]" size="30" maxlength="40" /></span>
					</p>
					<p class="field">
						<label for="fs1f5"><?php echo $lang_admin['Website'] ?></label><br />
						<span class="input"><input type="text" id="fs1f5" name="form[url]" size="35" maxlength="100" /></span>
					</p>
					<p class="field">
						<label for="fs1f6">Jabber</label><br />
						<span class="input"><input type="text" id="fs1f6" name="form[jabber]" size="30" maxlength="80" /></span>
					</p>
					<p class="field">
						<label for="fs1f7">ICQ</label><br />
						<span class="input"><input type="text" id="fs1f7" name="form[icq]" size="12" maxlength="12" /></span>
					</p>
					<p class="field">
						<label for="fs1f8">MSN Messenger</label><br />
						<span class="input"><input type="text" id="fs1f8" name="form[msn]" size="30" maxlength="80" /></span>
					</p>
					<p class="field">
						<label for="fs1f9">AOL IM</label><br />
						<span class="input"><input type="text" id="fs1f9" name="form[aim]" size="20" maxlength="20" /></span>
					</p>
					<p class="field">
						<label for="fs1f10">Yahoo! Messenger</label><br />
						<span class="input"><input type="text" id="fs1f10" name="form[yahoo]" size="20" maxlength="20" /></span>
					</p>
					<p class="field">
						<label for="fs1f11"><?php echo $lang_admin['Location'] ?></label><br />
						<span class="input"><input type="text" id="fs1f11" name="form[location]" size="30" maxlength="30" /></span>
					</p>
					<p class="field">
						<label for="fs1f12"><?php echo $lang_admin['Signature'] ?></label><br />
						<span class="input"><input type="text" id="fs1f12" name="form[signature]" size="35" maxlength="512" /></span>
					</p>
					<p class="field">
						<label for="fs1f13"><?php echo $lang_admin['Admin note'] ?></label><br />
						<span class="input"><input type="text" id="fs1f13" name="form[admin_note]" size="30" maxlength="30" /></span>
					</p>
					<p class="field">
						<label for="fs1f14"><?php echo $lang_admin['Posts greater than'] ?></label><br />
						<span class="input"><input type="text" id="fs1f14" name="posts_greater" size="5" maxlength="8" /> <em><?php echo $lang_admin['Number of posts'] ?></em></span>
					</p>
					<p class="field">
						<label for="fs1f15"><?php echo $lang_admin['Posts less than'] ?></label><br />
						<span class="input"><input type="text" id="fs1f15" name="posts_less" size="5" maxlength="8" /> <em><?php echo $lang_admin['Number of posts'] ?></em></span>
					</p>
					<p class="field">
						<label for="fs1f16"><?php echo $lang_admin['Last post after'] ?></label><br />
						<span class="input"><input type="text" id="fs1f16" name="last_post_after" size="24" maxlength="19" /> <em>(yyyy-mm-dd hh:mm:ss)</em></span>
					</p>
					<p class="field">
						<label for="fs1f17"><?php echo $lang_admin['Last post before'] ?></label><br />
						<span class="input"><input type="text" id="fs1f17" name="last_post_before" size="24" maxlength="19" /> <em>(yyyy-mm-dd hh:mm:ss)</em></span>
					</p>
					<p class="field">
						<label for="fs1f18"><?php echo $lang_admin['Registered after'] ?></label><br />
						<span class="input"><input type="text" id="fs1f18" name="registered_after" size="24" maxlength="19" /> <em>(yyyy-mm-dd hh:mm:ss)</em></span>
					</p>
					<p class="field">
						<label for="fs1f19"><?php echo $lang_admin['Registered before'] ?></label><br />
						<span class="input"><input type="text" id="fs1f19" name="registered_before" size="24" maxlength="19" /> <em>(yyyy-mm-dd hh:mm:ss)</em></span>
					</p>
				</fieldset>
				<fieldset class="textset" id="fs2">
					<legend><span><?php echo $lang_admin['User results legend'] ?></span></legend>
					<p class="field">
						<label for="fs2f1"><?php echo $lang_admin['Order by'] ?></label><br />
						<span class="input"><select id="fs2f1" name="order_by">
							<option value="username" selected="selected"><?php echo strtolower($lang_admin['Username']) ?></option>
							<option value="email"><?php echo strtolower($lang_admin['E-mail']) ?></option>
							<option value="num_posts"><?php echo strtolower($lang_admin['Posts']) ?></option>
							<option value="last_post"><?php echo $lang_admin['Last post'] ?></option>
							<option value="registered"><?php echo $lang_admin['Registered'] ?></option>
						</select></span>
					</p>
					<p class="field">
						<label for="fs2f2"><?php echo $lang_admin['Sort order'] ?></label><br />
						<span class="input"><select id="fs2f2" name="direction">
							<option value="ASC" selected="selected"><?php echo $lang_admin['Ascending'] ?></option>
							<option value="DESC"><?php echo $lang_admin['Descending'] ?></option>
						</select></span>
					</p>
					<p class="field">
						<label for="fs2f3"><?php echo $lang_admin['User group'] ?></label><br />
						<span class="input"><select id="fs2f3" name="user_group">
							<option value="all" selected="selected"><?php echo $lang_admin['All groups'] ?></option>
							<option value="<?php echo PUN_UNVERIFIED ?>"><?php echo $lang_admin['Unverified users'] ?></option>
<?php

	$result = $db->query('SELECT g_id, g_title FROM '.$db->prefix.'groups WHERE g_id!='.PUN_GUEST.' ORDER BY g_title') or error('Unable to fetch user group list', __FILE__, __LINE__, $db->error());

	while ($cur_group = $db->fetch_assoc($result))
		echo "\t\t\t\t\t\t\t".'<option value="'.$cur_group['g_id'].'">'.htmlspecialchars($cur_group['g_title']).'</option>'."\n";

?>
						</select></span>
					</p>
				</fieldset>
				<p class="formsubmit"><input type="submit" class="button" name="find_user" value="<?php echo $lang_admin['Submit search'] ?>" /></p>
			</div>
			</form>
			<form method="get" accept-charset="utf-8" action="<?php echo pun_link($pun_url['admin_users']) ?>">
			<div class="panel">
				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
				<div class="form-intro">
					<h2 class="prefix"><span><?php echo $lang_admin['IP search head'] ?>: </span></h2>
					<p><?php echo $lang_admin['IP search intro'] ?></p>
				</div>
				<fieldset class="textset" id="fs3">
					<legend><span><?php echo $lang_admin['IP search legend'] ?></span></legend>
					<p class="field">
						<label for="fs3f1"><?php echo $lang_admin['IP address'] ?></label><br />
						<span class="input"><input type="text" id="fs3f1" name="show_users" size="18" maxlength="15" /></span>
					</p>
				</fieldset>
				<p class="formsubmit"><input type="submit" value=" <?php echo $lang_admin['Submit search'] ?> " /></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php

	require PUN_ROOT.'footer.php';
}
