<?php
/***********************************************************************

  Copyright (C) 2002-2007  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


define('PUN_ROOT', './');
require PUN_ROOT.'include/common.php';


if ($pun_user['g_read_board'] == '0')
	message($lang_common['No view']);

// Load the delete.php language file
require PUN_ROOT.'lang/'.$pun_user['language'].'/delete.php';


$id = isset($_GET['id']) ? intval($_GET['id']) : 0;
if ($id < 1)
	message($lang_common['Bad request']);


// Fetch some info about the post, the topic and the forum
$result = $db->query('SELECT f.id AS fid, f.forum_name, f.moderators, f.redirect_url, fp.post_replies, fp.post_topics, t.id AS tid, t.subject, t.posted, t.first_post_id, t.closed, p.poster, p.poster_id, p.message, p.hide_smilies FROM '.$db->prefix.'posts AS p INNER JOIN '.$db->prefix.'topics AS t ON t.id=p.topic_id INNER JOIN '.$db->prefix.'forums AS f ON f.id=t.forum_id LEFT JOIN '.$db->prefix.'forum_perms AS fp ON (fp.forum_id=f.id AND fp.group_id='.$pun_user['g_id'].') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND p.id='.$id) or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());
if (!$db->num_rows($result))
	message($lang_common['Bad request']);

$cur_post = $db->fetch_assoc($result);

// Sort out who the moderators are and if we are currently a moderator (or an admin)
$mods_array = ($cur_post['moderators'] != '') ? unserialize($cur_post['moderators']) : array();
$is_admmod = ($pun_user['g_id'] == PUN_ADMIN || ($pun_user['g_moderator'] == '1' && array_key_exists($pun_user['username'], $mods_array))) ? true : false;

$is_topic_post = ($id == $cur_post['first_post_id']) ? true : false;

// Do we have permission to delete this post?
if (($pun_user['g_delete_posts'] == '0' ||
	($pun_user['g_delete_topics'] == '0' && $is_topic_post) ||
	$cur_post['poster_id'] != $pun_user['id'] ||
	$cur_post['closed'] == '1') &&
	!$is_admmod)
	message($lang_common['No permission']);


// User pressed the cancel button
if (isset($_POST['cancel']))
	redirect(pun_link($pun_url['post'], $id), $lang_common['Cancel redirect']);

// User pressed the delete button
else if (isset($_POST['delete']))
{
	if ($db_type != 'mysql' && $db_type != 'mysqli')
		require PUN_ROOT.'include/search_idx.php';

	if ($is_topic_post)
	{
		// Delete the topic and all of it's posts
		delete_topic($cur_post['tid']);
		update_forum($cur_post['fid']);

		redirect(pun_link($pun_url['forum'], $cur_post['fid']), $lang_delete['Topic del redirect']);
	}
	else
	{
		// Delete just this one post
		delete_post($id, $cur_post['tid']);
		update_forum($cur_post['fid']);

		redirect(pun_link($pun_url['topic'], $cur_post['tid']), $lang_delete['Post del redirect']);
	}
}


// Run the post through the parser
require PUN_ROOT.'include/parser.php';
$cur_post['message'] = parse_message($cur_post['message'], $cur_post['hide_smilies']);


// Setup breadcrumbs
$pun_page['crumbs'] = array(
	array($pun_config['o_board_title'], pun_link($pun_url['index'])),
	array($cur_post['forum_name'], pun_link($pun_url['forum'], $cur_post['fid'])),
	array($cur_post['subject'], pun_link($pun_url['topic'], $cur_post['tid'])),
	$lang_delete['Delete post']
);

define ('PUN_PAGE', 'postdelete');
require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

	<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['delete'], $id) ?>">
	<div class="b-section b-topic">
<?php if ($is_admmod): ?>		<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
<?php endif; ?>		<div class="post">
			<div class="posthead">
				<h3><cite class="author"><span><?php echo $lang_common['Posted by'] ?></span> <em><?php echo $cur_post['poster'] ?></em></cite> <abbr class="published" title="<?php echo date("Y-m-d\Th:i:s\Z", $cur_post['posted']) ?>"><a class="permalink" rel="bookmark" title="<?php echo $lang_delete['Permalink post'] ?>" href="<?php echo pun_link($pun_url['post'], $cur_post['tid']) ?>"><?php echo format_time($cur_post['posted']) ?></a></abbr></h3>
			</div>
			<div class="postmain">
				<div class="postbody">
					<div class="post-entry">
						<ul class="post-searchlinks">
							<li><strong><?php echo $lang_common['Forum'] ?></strong>: <span><?php echo htmlspecialchars($cur_post['forum_name']) ?></span></li>
							<li><strong><?php echo $lang_common['Topic'] ?></strong>: <span><?php echo htmlspecialchars($cur_post['subject']) ?></span></li>
						</ul>
						<div class="entry-content">
						<?php echo $cur_post['message'] ?>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>

	<div class="b-section b-mainoptions">
		<div class="c-section c-any">
			<p><?php if ($is_topic_post): ?><span class="mo-users"><?php echo '<strong>'.$lang_common['Warning'].'</strong> '.$lang_delete['Warning'] ?></span> <?php endif; ?><span class="mo-bottom"><input type="submit" class="button" name="delete" value="<?php echo $lang_delete['Delete'] ?>" /></span> <span class="mo-button"><input type="submit" class="button" name="cancel" value="<?php echo $lang_common['Cancel'] ?>" /></span></p>
		</div>
	</div>
	</form>

</div>

<?php

require PUN_ROOT.'footer.php';
