<?php
/***********************************************************************

  Copyright (C) 2002-2007  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


define('PUN_ROOT', './');
require PUN_ROOT.'include/common.php';


if ($pun_user['g_read_board'] == '0')
	message($lang_common['No view']);

// Load the index.php language file
require PUN_ROOT.'lang/'.$pun_user['language'].'/index.php';


// Get list of forums and topics with new posts since last visit
if (!$pun_user['is_guest'])
{
	$query = array(
		'SELECT'	=> 't.forum_id, t.id, t.last_post',
		'FROM'		=> 'topics AS t',
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'forums AS f',
				'ON'			=> 'f.id=t.forum_id'
			),
			array(
				'LEFT JOIN'		=> 'forum_perms AS fp',
				'ON'			=> '(fp.forum_id=f.id AND fp.group_id='.$pun_user['g_id'].')'
			)
		),
		'WHERE'		=> '(fp.read_forum IS NULL OR fp.read_forum=1) AND t.last_post>'.$pun_user['last_visit'].' AND t.moved_to IS NULL'
	);

	($hook = get_hook('in_qr_get_new_topics')) ? eval($hook) : null;
	$result = $db->query_build($query, true) or error('Unable to fetch new topics list', __FILE__, __LINE__, $db->error());

	$new_topics = array();
	while ($cur_topic = $db->fetch_assoc($result))
		$new_topics[$cur_topic['forum_id']][$cur_topic['id']] = $cur_topic['last_post'];

	$tracked_topics = get_tracked_topics();
}


define('PUN_ALLOW_INDEX', 1);
define('PUN_PAGE', 'index');
require PUN_ROOT.'header.php';

// Print the categories and forums
$query = array(
	'SELECT'	=> 'c.id AS cid, c.cat_name, f.id AS fid, f.forum_name, f.forum_desc, f.redirect_url, f.moderators, f.num_topics, f.num_posts, f.last_post, f.last_post_id, f.last_poster',
	'FROM'		=> 'categories AS c',
	'JOINS'		=> array(
		array(
			'INNER JOIN'	=> 'forums AS f',
			'ON'			=> 'c.id=f.cat_id'
		),
		array(
			'LEFT JOIN'		=> 'forum_perms AS fp',
			'ON'			=> '(fp.forum_id=f.id AND fp.group_id='.$pun_user['g_id'].')'
		)
	),
	'WHERE'		=> 'fp.read_forum IS NULL OR fp.read_forum=1',
	'ORDER BY'	=> 'c.disp_position, c.id, f.disp_position'
);

($hook = get_hook('in_qr_get_cats_and_forums')) ? eval($hook) : null;
$result = $db->query_build($query, true) or error('Unable to fetch category/forum list', __FILE__, __LINE__, $db->error());

$cur_category = 0;
$cat_count = 0;
$row_count = 0;
while ($cur_forum = $db->fetch_assoc($result))
{
	$moderators = '';
	++$row_count;

	if ($cur_forum['cid'] != $cur_category)	// A new category since last iteration?
	{
		if ($cur_category != 0)
		{

?>
			</tbody>
			</table>
		</div>
	</div>

</div>

<?php

		}

		++$cat_count;
		$row_count = 1;

?>
<div id="pun-main<?php echo $cat_count ?>" class="a-section a-main">

	<h2 class="main-title"><span><?php echo htmlspecialchars($cur_forum['cat_name']) ?></span></h2>

	<div id="category<?php echo $cat_count ?>" class="b-section b-category">
		<div class="c-section c-table">
			<table cellspacing="0" summary="<?php printf($lang_index['Table summary'], htmlspecialchars($cur_forum['cat_name'])) ?>">
			<thead>
				<tr>
					<th class="tcl" scope="col"><?php echo $lang_common['Forum'] ?></th>
					<th class="tc2" scope="col"><?php echo $lang_index['Topics'] ?></th>
					<th class="tc3" scope="col"><?php echo $lang_common['Posts'] ?></th>
					<th class="tcr" scope="col"><?php echo $lang_common['Last post'] ?></th>
				</tr>
			</thead>
			<tbody class="hasicon">
<?php

		$cur_category = $cur_forum['cid'];
	}

	$icon_type = 'icon';
	$row_style = ($row_count % 2 != 0) ? 'altstyle' : '';

	// Is this a redirect forum?
	if ($cur_forum['redirect_url'] != '')
	{
		$forum_link = '<a href="'.htmlspecialchars($cur_forum['redirect_url']).'" title="'.sprintf($lang_index['Link to'], htmlspecialchars($cur_forum['redirect_url'])).'"><strong>'.htmlspecialchars($cur_forum['forum_name']).'</strong></a> <span class="acchide">- '.$lang_common['Redirected forum'].'</span>';
		$num_topics = $num_posts = '&#160;';
		$row_style .= ' iredirect';
	}
	else
	{
		$forum_link = '<a href="'.pun_link($pun_url['forum'], array($cur_forum['fid'],sef_friendly($cur_forum['forum_name']))).'"><strong>'.htmlspecialchars($cur_forum['forum_name']).'</strong></a>';
		$num_topics = $cur_forum['num_topics'];
		$num_posts = $cur_forum['num_posts'];
	}

	// Are there new posts since our last visit?
	if (!$pun_user['is_guest'] && $cur_forum['last_post'] > $pun_user['last_visit'])
	{
		// There are new posts in this forum, but have we read all of them already?
		$unread_topics = false;
		while (list($check_topic_id, $check_last_post) = @each($new_topics[$cur_forum['fid']]))
		{
			if (empty($tracked_topics[$check_topic_id]) || $tracked_topics[$check_topic_id] < $check_last_post)
				$unread_topics = true;
		}

		if ($unread_topics)
		{
			$row_style .= ' inew';
			$icon_type .= ' inew';
			$forum_link .= '<strong class="acchide">[ '.$lang_common['New posts'].' ]</strong> ';
		}
	}

	if ($cur_forum['forum_desc'] != '')
		$forum_link .= '<br />'.$cur_forum['forum_desc'];

	// If there is a last_post/last_poster.
	if ($cur_forum['last_post'] != '')
		$last_post = '<a href="'.pun_link($pun_url['post'], $cur_forum['last_post_id']).'">'.format_time($cur_forum['last_post']).'</a><br />'.$lang_common['by'].'&#160;'.htmlspecialchars($cur_forum['last_poster']);
	else
		$last_post = '&#160;';

	if ($cur_forum['moderators'] != '')
	{
		$mods_array = unserialize($cur_forum['moderators']);
		$moderators = array();

		while (list($mod_username, $mod_id) = @each($mods_array))
			$moderators[] = '<a href="'.pun_link($pun_url['user'], $mod_id).'">'.htmlspecialchars($mod_username).'</a>';

		$moderators = '<br /><span class="modlist">('.sprintf($lang_index['Moderated by'], implode(', ', $moderators)).')</span>';
	}

?>
				<tr id="forum<?php echo $cur_forum['fid'] ?>"<?php if ($row_style != '') echo ' class="'.trim($row_style).'"' ?>>
					<td class="tcl"><div class="<?php echo $icon_type ?>"><!-- --></div><?php echo $forum_link.$moderators ?></td>
					<td class="tc2"><?php echo $num_topics ?></td>
					<td class="tc3"><?php echo $num_posts ?></td>
					<td class="tcr"><?php echo $last_post ?></td>
				</tr>
<?php

}

// Did we output any categories and forums?
if ($cur_category > 0)
{

?>
			</tbody>
			</table>
		</div>
	</div>

</div>
<?php

}
else
{

?>
<div id="pun-main1" class="a-section a-main">

	<h2 class="main-title"><span><?php echo $lang_common['Info'] ?></span></h2>

	<div class="b-section b-message">
		<div class="c-section c-any">
			<p><?php echo $lang_index['Empty board'] ?></p>
		</div>
	</div>

</div>
<?php

}

require PUN_ROOT.'footer.php';
