<?php

// Language definitions for frequently used strings
$lang_common = array(

// Text orientation and encoding
'lang_direction'		=>	'ltr',	// ltr (Left-To-Right) or rtl (Right-To-Left)
'lang_identifier'		=>	'en',
'lang_multibyte'		=>	false,

// Notices
'Bad request'			=>	'Bad request. The link you followed is incorrect or outdated.',
'No view'				=>	'You do not have permission to view these forums.',
'No permission'			=>	'You do not have permission to access this page.',
'CSRF token mismatch'	=>	'Unable to confirm security token. A likely cause for this is that some time passed between when you first entered the page and when you posted the form.',
'No cookie'				=>	'You appear to have logged in successfully, however a cookie has not been set. Please check your settings and if applicable enable cookies for this website.',

// Topic/forum indicators
'Closed'				=>	'[Closed]',
'Redirected forum'		=>	'Redirected forum',

// Miscellaneous
'Forum index'			=>	'Forum index',
'Submit'				=>	'Submit',	// "name" of submit buttons
'Cancel'				=>	'Cancel', // "name" of cancel buttons
'Submit title'			=>	'Accesskey: s', // "title" for submit buttons
'Ban message'			=>	'You are banned from this forum.',
'Ban message 2'			=>	'The ban expires at the end of %s.',
'Ban message 3'			=>	'The administrator or moderator that banned you left the following message:',
'Ban message 4'			=>	'Please direct any inquiries to the forum administrator at %s.',
'Never'					=>	'Never',
'Today'					=>	'Today',
'Yesterday'				=>	'Yesterday',
'Info'					=>	'Info',		// a common message box header
'Maintenance'			=>	'Maintenance',
'Redirecting'			=>	'Redirecting',
'Click redirect'		=>	'Click here if you do not want to wait any longer (or if your browser does not automatically forward you)',
'Invalid e-mail'		=>	'The e-mail address you entered is invalid.',
'Last post'				=>	'Last post',
'by'					=>	'by',	// as in last post by someuser
'Posted by'				=>	'Posted by',
'New posts'				=>	'New posts',	// the link that leads to the first new post
'New posts info'		=>	'Go to the first new post in this topic.',	// the popup text for new posts links
'Username'				=>	'Username',
'Password'				=>	'Password',
'E-mail'				=>	'E-mail',
'E-mail address'		=>	'E-mail address',
'Send e-mail'			=>	'Send&#160;e-mail',
'Send e-mail to'		=>	'Send e-mail to %s',
'Registered'			=>	'Registered',
'Subject'				=>	'Subject',
'Message'				=>	'Message',
'Topic'					=>	'Topic',
'Forum'					=>	'Forum',
'Posts'					=>	'Posts',
'Replies'				=>	'Replies',
'Author'				=>	'Author',
'Pages'					=>	'Pages',
'Page'					=>	'Page',
'BBCode'				=>	'BBCode',	// You probably shouldn't change this
'Smilies'				=>	'Smilies',
'BBCode help'			=>	'BBCode help',
'img tag help'			=>	'[img] tag help',
'Smilies help'			=>	'Smilies help',
'and'					=>	'and',
'Image link'			=>	'image',	// This is displayed (i.e. <image>) instead of images when "Show images" is disabled in the profile
'wrote'					=>	'wrote',	// For [quote]'s (e.g., User wrote:)
'Code'					=>	'Code',		// For [code]'s
'Forum mailer'			=>	'%s Mailer',	// As in "MyForums Mailer" in the signature of outgoing e-mails
'Important'				=>	'Important:',
'Warning'				=>	'Warning!',
'Write message legend'	=>	'Write and submit your message',
'Required mark'			=>	'*',
'Required'				=>	'(Required)',
'Required warn'			=>	'All fields marked %s must be completed before submission of this form can be accepted.',
'You are here'			=>	'You are here: ',
'Crumb separator'		=>	' »&#160;', // The character or text that seperates links in breadcrumbs
'Title separator'		=>	' - ',
'Page separator'		=>	'&#160;', //The character or text that seperates page numbers
'Previous'				=>	'Previous',
'Next'					=>	'Next',
'Cancel redirect'		=>	'Operation cancelled. Redirecting …',
'Approval warning'		=>	'Your post will have to be approved by a moderator before it will appear to normal users.',
'Approval guest warning'=>	'Your post will have to be approved by a moderator before it will appear to normal users, as you are a guest you will not be able to view your post until it has been approved.',

// Title
'Title'					=>	'Title',
'Member'				=>	'Member',	// Default title
'Moderator'				=>	'Moderator',
'Administrator'			=>	'Administrator',
'Banned'				=>	'Banned',
'Guest'					=>	'Guest',

// Stuff for include/parser.php
'BBCode error'			=>	'The BBCode syntax in the message is incorrect.',
'BBCode error 1'		=>	'Missing start tag for [/quote].',
'BBCode error 2'		=>	'Missing end tag for [code].',
'BBCode error 3'		=>	'Missing start tag for [/code].',
'BBCode error 4'		=>	'Missing one or more end tags for [quote].',
'BBCode error 5'		=>	'Missing one or more start tags for [/quote].',

// Stuff for the navigator (top of every page)
'Navigation'			=>	'Forum navigation',
'Index'					=>	'Index',
'User list'				=>	'User list',
'Rules'					=>  'Rules',
'Search'				=>  'Search',
'Register'				=>  'Register',
'Login'					=>  'Login',
'Not logged in'			=>  'You are not logged in.',
'Profile'				=>	'Profile',
'Logout'				=>	'Logout',
'Logged in as'			=>	'Logged in as %s.',
'Admin'					=>	'Administration',
'Last visit'			=>	'Last visit: %s',
'Mark all as read'		=>	'Mark all topics as read',
'Login nag'				=>	'Please login or register',
'New reports'			=>	'New reports',
'Maintenance mode'		=>	'Maintenance mode is enabled!',

// Stuff for Quick Links menu page footer
'Show new posts'		=>	'Show new posts',
'Show new posts info'	=>	'Lists topics that have new posts since your last visit',
'Show recent posts'		=>	'Recent posts',
'Show unanswered posts'	=>	'Unanswered posts',
'Show your posts'		=>	'Your posts',
'Show subscriptions'	=>	'Your subscriptions',
'Jump to'				=>	'Go to selected forum',
'Quick jump legend'		=>	'Forum quick jump menu',
'Go'					=>	' Go ',		// submit button in forum jump
'Debug table'			=>	'Debug information',

// For extern.php RSS feed
'ATOM Feed'				=>	'Atom Feed',
'RSS Feed'				=>	'RSS Feed',
'RSS description'		=>	'The most recent topics at %s.',
'RSS description topic'	=>	'The most recent posts in %s.',
'RSS reply'				=>	'Re: ',	// The topic subject will be appended to this string (to signify a reply)

// Accessibility
'Skip to content'		=>	'Skip to forum content',
'Skip to nav'			=>	'Skip to forum navigation',
'New window warn'		=>	'Page opens in a new window if javascript is enabled.',
'Back to top'			=>	'Back to top'

);



