<?php
/***********************************************************************

  Copyright (C) 2002-2007  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


define('PUN_ROOT', './');
require PUN_ROOT.'include/common.php';


if ($pun_user['g_read_board'] == '0')
	message($lang_common['No view']);

// Load the viewtopic.php language file
require PUN_ROOT.'lang/'.$pun_user['language'].'/topic.php';


$action = isset($_GET['action']) ? $_GET['action'] : null;
$id = isset($_GET['id']) ? intval($_GET['id']) : 0;
$pid = isset($_GET['pid']) ? intval($_GET['pid']) : 0;
if ($id < 1 && $pid < 1)
	message($lang_common['Bad request']);


// If a post ID is specified we determine topic ID and page number so we can redirect to the correct message
if ($pid)
{
	$query = array(
		'SELECT'	=> 'p.topic_id, p.posted',
		'FROM'		=> 'posts AS p',
		'WHERE'		=> 'p.id='.$pid
	);

	($hook = get_hook('vt_qr_get_post_info')) ? eval($hook) : null;
	$result = $db->query_build($query) or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());
	if (!$db->num_rows($result))
		message($lang_common['Bad request']);

	list($id, $posted) = $db->fetch_row($result);

	// Determine on what page the post is located (depending on $pun_user['disp_posts'])
	$query = array(
		'SELECT'	=> '1',
		'FROM'		=> 'posts AS p',
		'WHERE'		=> 'p.topic_id='.$id.' AND p.posted<'.$posted
	);

	($hook = get_hook('vt_qr_get_post_page')) ? eval($hook) : null;
	$result = $db->query_build($query) or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());
	$num_posts = $db->num_rows($result) + 1;

	$_GET['p'] = ceil($num_posts / $pun_user['disp_posts']);
}

// If action=new, we redirect to the first new post (if any)
else if ($action == 'new' && !$pun_user['is_guest'])
{
	// We need to check if this topic has been viewed recently by the user
	$tracked_topics = get_tracked_topics();
	$last_viewed = isset($tracked_topics[$id]) ? $tracked_topics[$id] : $pun_user['last_visit'];

	$query = array(
		'SELECT'	=> 'MIN(p.id)',
		'FROM'		=> 'posts AS p',
		'WHERE'		=> 'p.topic_id='.$id.' AND p.posted>'.$last_viewed
	);

	($hook = get_hook('vt_qr_get_first_new_post')) ? eval($hook) : null;
	$result = $db->query_build($query) or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());
	$first_new_post_id = $db->result($result);

	if ($first_new_post_id)
		header('Location: '.str_replace('&amp;', '&', pun_link($pun_url['post'], $first_new_post_id)));
	else	// If there is no new post, we go to the last post
		header('Location: '.str_replace('&amp;', '&', pun_link($pun_url['topic_last_post'], $id)));

	exit;
}

// If action=last, we redirect to the last post
else if ($action == 'last')
{
	$query = array(
		'SELECT'	=> 'MAX(p.id)',
		'FROM'		=> 'posts AS p',
		'WHERE'		=> 'p.topic_id='.$id
	);

	($hook = get_hook('vt_qr_get_last_post')) ? eval($hook) : null;
	$result = $db->query_build($query) or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());
	$last_post_id = $db->result($result);

	if ($last_post_id)
	{
		header('Location: '.str_replace('&amp;', '&', pun_link($pun_url['post'], $last_post_id)));
		exit;
	}
}


// Fetch some info about the topic
$query = array(
	'SELECT'	=> 't.subject, t.posted, t.poster, t.first_post_id, t.closed, t.num_replies, t.sticky, f.id AS forum_id, f.forum_name, f.moderators, f.approval, fp.post_replies',
	'FROM'		=> 'topics AS t',
	'JOINS'		=> array(
		array(
			'INNER JOIN'	=> 'forums AS f',
			'ON'			=> 'f.id=t.forum_id'
		),
		array(
			'LEFT JOIN'		=> 'forum_perms AS fp',
			'ON'			=> '(fp.forum_id=f.id AND fp.group_id='.$pun_user['g_id'].')'
		)
	),
	'WHERE'		=> '(fp.read_forum IS NULL OR fp.read_forum=1) AND t.id='.$id.' AND t.moved_to IS NULL'
);

if (!$pun_user['is_guest'])
{
	$query['SELECT'] .= ', s.user_id AS is_subscribed';
	$query['JOINS'][] = array(
		'LEFT JOIN'	=> 'subscriptions AS s',
		'ON'		=> '(t.id=s.topic_id AND s.user_id='.$pun_user['id'].')'
	);
}

($hook = get_hook('vt_qr_get_topic_info')) ? eval($hook) : null;
$result = $db->query_build($query) or error('Unable to fetch topic info', __FILE__, __LINE__, $db->error());
if (!$db->num_rows($result))
	message($lang_common['Bad request']);

$cur_topic = $db->fetch_assoc($result);

// Sort out who the moderators are and if we are currently a moderator (or an admin)
$mods_array = ($cur_topic['moderators'] != '') ? unserialize($cur_topic['moderators']) : array();
$is_admmod = ($pun_user['g_id'] == PUN_ADMIN || ($pun_user['g_moderator'] == '1' && array_key_exists($pun_user['username'], $mods_array))) ? true : false;

// See if the first post needs approving and therefore if the topic can be shown to non-admin/moderators
if ($cur_topic['approval'] == 1 && !$is_admmod)
{
	// Check the first post
	$query = array(
		'SELECT'	=> 'p.approved, p.poster_id',
		'FROM'		=> 'posts AS p',
		'WHERE'		=> 'p.id='.$cur_topic['first_post_id']
	);

	($hook = get_hook('vt_qr_get_first_post_info')) ? eval($hook) : null;
	$result = $db->query_build($query) or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());
	list($approved, $poster_id) = $db->fetch_row($result);
	if ($approved == 0 && $poster_id != $pun_user['id'])
		message($lang_common['Bad request']);
}

// Determine the post offset (based on $_GET['p'])
$num_pages = ceil(($cur_topic['num_replies'] + 1) / $pun_user['disp_posts']);

$p = (!isset($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $num_pages) ? 1 : $_GET['p'];
$start_from = $pun_user['disp_posts'] * ($p - 1);
$finish_at = min(($start_from + $pun_user['disp_posts']), ($cur_topic['num_replies'] + 1));

// Generate paging links
$main_links = '<div class="pagelinks">'.$lang_common['Pages'].': '.paginate($num_pages, $p, $pun_url['topic'], array($id, sef_friendly($cur_topic['subject']))).'</div>';

// Can we or can we not post replies?
if ($cur_topic['closed'] == '0')
{
	if (($cur_topic['post_replies'] == '' && $pun_user['g_post_replies'] == '1') || $cur_topic['post_replies'] == '1' || $is_admmod)
		$main_links .= "\n\t\t".'<div class="postlink"><a class="newpost" href="'.pun_link($pun_url['new_reply'], $id).'"><span>'.$lang_topic['Post reply'].'</span></a></div>';
}
else
{
	if ($is_admmod)
		$main_links .= "\n\t\t".'<div class="postlink"><span class="postclosed"><strong>'.$lang_topic['Topic closed'].'</strong></span> / <a class="newpost" href="'.pun_link($pun_url['new_reply'], $id).'">'.$lang_topic['Post reply'].'</a></div>';
	else
		$main_links .= "\n\t\t".'<div class="postlink"><span class="postclosed"><strong>'.$lang_topic['Topic closed'].'</strong></span></div>'."\n";
}

// Add/update this topic in our list of tracked topics
if (!$pun_user['is_guest'])
{
	$tracked_topics = get_tracked_topics();
	$tracked_topics[$id] = time();
	set_tracked_topics($tracked_topics);
}

if ($pun_config['o_censoring'] == '1')
	$cur_topic['subject'] = censor_words($cur_topic['subject']);


// Navigation links for header and page numbering for title/meta description
if ($p < $num_pages)
{
	$pun_page['nav'][] = '<link rel="last" href="'.pun_sublink($pun_url['topic'], $pun_url['page'], $num_pages, array($id, sef_friendly($cur_topic['subject']))).'" title="'.$lang_common['Page'].' '.$num_pages.'" />';
	$pun_page['nav'][] = '<link rel="next" href="'.pun_sublink($pun_url['topic'], $pun_url['page'], ($p + 1), array($id, sef_friendly($cur_topic['subject']))).'" title="'.$lang_common['Page'].' '.($p + 1).'" />';
}
if ($p > 1)
{
	$pun_page['nav'][] = '<link rel="prev" href="'.pun_sublink($pun_url['topic'], $pun_url['page'], ($p - 1), array($id, sef_friendly($cur_topic['subject']))).'" title="'.$lang_common['Page'].' '.($p - 1).'" />';
	$pun_page['nav'][] = '<link rel="first" href="'.pun_link($pun_url['topic'], array($id, sef_friendly($cur_topic['subject']))).'" title="'.$lang_common['Page'].' 1" />';
	$pun_page['page'] = $p;
}

// Setup breadcrumbs
$pun_page['crumbs'] = array(
	array($pun_config['o_board_title'], pun_link($pun_url['index'])),
	array($cur_topic['forum_name'], pun_link($pun_url['forum'], array($cur_topic['forum_id'], sef_friendly($cur_topic['forum_name'])))),
	$cur_topic['subject']
);

define('PUN_ALLOW_INDEX', 1);
define('PUN_PAGE', 'viewtopic');
require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main paged">

	<h1 class="main-title"><span><a class="permalink" href="<?php echo pun_link($pun_url['topic'], array($id, sef_friendly($cur_topic['subject']))) ?>" rel="bookmark" title="<?php echo $lang_topic['Permalink topic'] ?>"><?php echo htmlspecialchars($cur_topic['subject']) ?></a></span></h1>

	<div class="main-head">
		<?php echo $main_links."\n" ?>
	</div>

	<div id="forum<?php echo $cur_topic['forum_id'] ?>" class="b-section b-topic">
		<h2><span><?php printf($lang_topic['Posts selection'], $start_from + 1, $finish_at, $cur_topic['num_replies'] + 1) ?></span></h2>

<?php

require PUN_ROOT.'include/parser.php';

$post_count = 0;	// Keep track of post numbers

// Retrieve the posts (and their respective poster/online status)
$query = array(
	'SELECT'	=> 'u.email, u.title, u.url, u.location, u.signature, u.email_setting, u.num_posts, u.registered, u.admin_note, p.id, p.poster AS username, p.poster_id, p.poster_ip, p.poster_email, p.message, p.hide_smilies, p.approved, p.posted, p.edited, p.edited_by, g.g_id, g.g_user_title, o.user_id AS is_online',
	'FROM'		=> 'posts AS p',
	'JOINS'		=> array(
		array(
			'INNER JOIN'	=> 'users AS u',
			'ON'			=> 'u.id=p.poster_id'
		),
		array(
			'INNER JOIN'	=> 'groups AS g',
			'ON'			=> 'g.g_id=u.group_id'
		),
		array(
			'LEFT JOIN'		=> 'online AS o',
			'ON'			=> '(o.user_id=u.id AND o.user_id!=1 AND o.idle=0)'
		),
	),
	'WHERE'		=> 'p.topic_id='.$id,
	'ORDER BY'	=> 'p.id',
	'LIMIT'		=> $start_from.','.$pun_user['disp_posts']
);

if (!$is_admmod)
	$query['WHERE'] .= $pun_user['is_guest'] ? ' AND p.approved=1 ' : ' AND (p.approved=1 OR p.poster_id='.$pun_user['id'].')';

($hook = get_hook('vt_qr_get_posts')) ? eval($hook) : null;
$result = $db->query_build($query, true) or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());
while ($cur_post = $db->fetch_assoc($result))
{
	++$post_count;
	$post_head = array('<strong>'.($start_from + $post_count).'</strong>');
	$post_author = array('<li class="pa-title">'.get_title($cur_post).'</li>');
	$post_options = array();
	$signature = '';

	// If the poster is a registered user.
	if ($cur_post['poster_id'] > 1)
	{
		// Online/offline status
		$post_options[] = '<li class="po-status"><strong>'.($cur_post['is_online'] == $cur_post['poster_id'] ? $lang_topic['Online'] : $lang_topic['Offline']).'</strong></li>';

		if ($pun_user['g_view_users'] == '1' || $pun_user['id'] == $cur_post['poster_id'])
			$post_head[] = '<cite><span>'.($cur_topic['posted'] == $cur_post['posted'] ? $lang_topic['Topic by'] : $lang_topic['Reply by']).'</span> <a title="'.sprintf($lang_topic['Go to profile'], htmlspecialchars($cur_post['username'])).'" href="'.pun_link($pun_url['user'], $cur_post['poster_id']).'">'.htmlspecialchars($cur_post['username']).'</a></cite>';
		else
			$post_head[] = '<cite><span>'.($cur_topic['posted'] == $cur_post['posted'] ? $lang_topic['Topic by'] : $lang_topic['Reply by']).'</span> <em>'.htmlspecialchars($cur_post['username']).'</em></cite>';

		if ($pun_config['o_avatars'] == '1' && $pun_user['show_avatars'] != '0')
		{
			if ($img_size = @getimagesize($pun_config['o_avatars_dir'].'/'.$cur_post['poster_id'].'.gif'))
				$post_author[] = '<li class="pa-avatar"><img src="'.$base_url.'/'.$pun_config['o_avatars_dir'].'/'.$cur_post['poster_id'].'.gif" '.$img_size[3].' alt="'.$lang_topic['Avatar'].'" /></li>';
			else if ($img_size = @getimagesize($pun_config['o_avatars_dir'].'/'.$cur_post['poster_id'].'.jpg'))
				$post_author[] = '<li class="pa-avatar"><img src="'.$base_url.'/'.$pun_config['o_avatars_dir'].'/'.$cur_post['poster_id'].'.jpg" '.$img_size[3].' alt="'.$lang_topic['Avatar'].'" /></li>';
			else if ($img_size = @getimagesize($pun_config['o_avatars_dir'].'/'.$cur_post['poster_id'].'.png'))
				$post_author[] = '<li class="pa-avatar"><img src="'.$base_url.'/'.$pun_config['o_avatars_dir'].'/'.$cur_post['poster_id'].'.png" '.$img_size[3].' alt="'.$lang_topic['Avatar'].'" /></li>';
			else
				$user_avatar = '';
		}

		// We only show location, register date, post count and the contact links if "Show user info" is enabled
		if ($pun_config['o_show_user_info'] == '1')
		{
			if ($cur_post['location'] != '')
			{
				if ($pun_config['o_censoring'] == '1')
					$cur_post['location'] = censor_words($cur_post['location']);

				$post_author[] = '<li class="pa-from">'.$lang_topic['From'].': '.htmlspecialchars($cur_post['location']).'</li>';
			}

			$post_author[] = '<li class="pa-reg">'.$lang_common['Registered'].': '.format_time($cur_post['registered'], true).'</li>';

			if ($pun_config['o_show_post_count'] == '1' || $pun_user['is_admmod'])
				$post_author[] = '<li class="pa-posts">'.$lang_common['Posts'].': '.$cur_post['num_posts'].'</li>';

			// Now let's deal with the contact links (E-mail and URL)
			if ($cur_post['url'] != '')
				$post_options[] = '<li class="po-contact po-www"><a href="'.htmlspecialchars($cur_post['url']).'"><span class="acchide">'.sprintf($lang_topic['Visit author'], htmlspecialchars($cur_post['username'])).'</span>'.' '.$lang_topic['Website'].'</a></li>';
			if (($cur_post['email_setting'] == '0' && !$pun_user['is_guest']) || $pun_user['is_admmod'])
				$post_options[] = '<li class="po-contact po-email"><a href="mailto:'.$cur_post['email'].'">'.$lang_common['E-mail'].'<span class="acchide">&#160;'.htmlspecialchars($cur_post['username']).'</span></a></li>';
			else if ($cur_post['email_setting'] == '1' && !$pun_user['is_guest'])
				$post_options[] = '<li class="po-contact po-email"><a href="'.pun_link($pun_url['email'], $cur_post['poster_id']).'">'.$lang_common['E-mail'].'<span class="acchide">&#160;'.htmlspecialchars($cur_post['username']).'</span></a></li>';
		}

		if ($pun_user['is_admmod'])
		{
			$post_author[] = '<li class="pa-ip">IP: <a href="'.pun_link($pun_url['get_host'], $cur_post['id']).'">'.$cur_post['poster_ip'].'</a></li>';

			if ($cur_post['admin_note'] != '')
				$post_author[] = '<li class="pa-adnote">'.$lang_topic['Note'].': '.htmlspecialchars($cur_post['admin_note']).'</li>';
		}
	}
	// If the poster is a guest (or a user that has been deleted)
	else
	{
		$post_head[] = '<cite><span>'.($cur_topic['posted'] == $cur_post['posted'] ? $lang_topic['Topic by'] : $lang_topic['Reply by']).'</span> <em>'.htmlspecialchars($cur_post['username']).'</em></cite>';

		if ($pun_user['is_admmod'])
			$post_author[] = '<li class="pa-ip">IP: <a href="'.pun_link($pun_url['get_host'], $cur_post['id']).'">'.$cur_post['poster_ip'].'</a></li>';

		if ($pun_config['o_show_user_info'] == '1' && $cur_post['poster_email'] != '' && !$pun_user['is_guest'])
			$post_options[] = '<li class="po-contact po-email"><a href="mailto:'.$cur_post['poster_email'].'">'.$lang_common['E-mail'].'<span class="acchide">&#160;'.htmlspecialchars($cur_post['username']).'</span></a></li>';
	}

	($hook = get_hook('vt_view_post1')) ? eval($hook) : null;

	// Generate the post action array (quote, edit, delete etc.)
	if (!$is_admmod)
	{
		if (!$pun_user['is_guest'])
		{
			$post_options[] = '<li class="po-menu po-report"><a href="'.pun_link($pun_url['report'], $cur_post['id']).'">'.$lang_topic['Report'].'<span class="acchide">&#160;'.$lang_topic['Post'].' '.($start_from + $post_count).'</span></a></li>';

			if ($cur_topic['closed'] == '0')
			{
				if ($cur_post['poster_id'] == $pun_user['id'])
				{
					if ((($start_from + $post_count) == 1 && $pun_user['g_delete_topics'] == '1') || (($start_from + $post_count) > 1 && $pun_user['g_delete_posts'] == '1'))
						$post_options[] = '<li class="po-menu po-delete"><a href="'.pun_link($pun_url['delete'], $cur_post['id']).'">'.$lang_topic['Delete'].'<span class="acchide">&#160;'.$lang_topic['Post'].' '.($start_from + $post_count).'</span></a></li>';
					if ($pun_user['g_edit_posts'] == '1')
						$post_options[] = '<li class="po-menu po-edit"><a href="'.pun_link($pun_url['edit'], $cur_post['id']).'">'.$lang_topic['Edit'].'<span class="acchide">&#160;'.$lang_topic['Post'].' '.($start_from + $post_count).'</span></a></li>';
				}

				if (($cur_topic['post_replies'] == '' && $pun_user['g_post_replies'] == '1') || $cur_topic['post_replies'] == '1')
					$post_options[] = '<li class="po-menu po-quote"><a href="'.pun_link($pun_url['quote'], array($id, $cur_post['id'])).'">'.$lang_topic['Quote'].'<span class="acchide">&#160;'.$lang_topic['Post'].' '.($start_from + $post_count).'</span></a></li>';
			}
		}
	}
	else
	{
		$post_options[] = '<li class="po-menu po-report"><a href="'.pun_link($pun_url['report'], $cur_post['id']).'">'.$lang_topic['Report'].'<span class="acchide">&#160;'.$lang_topic['Post'].' '.($start_from + $post_count).'</span></a></li>';
		$post_options[] = '<li class="po-menu po-delete"><a href="'.pun_link($pun_url['delete'], $cur_post['id']).'">'.$lang_topic['Delete'].'<span class="acchide">&#160;'.$lang_topic['Post'].' '.($start_from + $post_count).'</span></a></li>';
		$post_options[] = '<li class="po-menu po-edit"><a href="'.pun_link($pun_url['edit'], $cur_post['id']).'">'.$lang_topic['Edit'].'<span class="acchide">&#160;'.$lang_topic['Post'].' '.($start_from + $post_count).'</span></a></li>';
		$post_options[] = '<li class="po-menu po-quote"><a href="'.pun_link($pun_url['quote'], array($id, $cur_post['id'])).'">'.$lang_topic['Quote'].'<span class="acchide">&#160;'.$lang_topic['Post'].' '.($start_from + $post_count).'</span></a></li>';
		if ($cur_post['approved'] == 0 && $cur_topic['approval'] == 1)
			$post_options[] = '<li class="po-menu po-approve"><a href="'.pun_link($pun_url['approve'], $cur_post['id']).'">'.$lang_topic['Approve'].'<span class="acchide">&#160;'.$lang_topic['Post'].' '.($start_from + $post_count).'</span></a></li>';
	}

	($hook = get_hook('vt_view_post2')) ? eval($hook) : null;

	// Complete setup of the post header array
	$post_head[] = '<a class="permalink" rel="bookmark" title="'.$lang_topic['Permalink post'].'" href="'.pun_link($pun_url['post'], $cur_post['id']).'">'.format_time($cur_post['posted']).'</a>';

	// Perform the main parsing of the message (BBCode, smilies, censor words etc)
	$cur_post['message'] = parse_message($cur_post['message'], $cur_post['hide_smilies']);

	// Do signature parsing/caching
	if ($cur_post['signature'] != '' && $pun_user['show_sig'] != '0' && $pun_config['o_signatures'] == '1')
	{
		if (isset($signature_cache[$cur_post['poster_id']]))
			$signature = $signature_cache[$cur_post['poster_id']];
		else
		{
			$signature = parse_signature($cur_post['signature']);
			$signature_cache[$cur_post['poster_id']] = $signature;
		}
	}

?>
		<div class="post<?php if ($post_count % 2 == 0) echo ' altstyle'; if ($cur_post['approved'] == 0 && $cur_topic['approval'] == 1) echo ' unapproved' ?><?php if ($cur_post['is_online'] == $cur_post['poster_id']) echo ' online' ?>">
			<div id="p<?php echo $cur_post['id'] ?>" class="posthead">
				<h3><?php echo implode(' ', $post_head) ?></h3>
			</div>
			<div class="postmain">
				<div class="postbody">
					<ul class="post-author">
						<?php echo implode("\n\t\t\t\t\t\t", $post_author)."\n"; ?>
					</ul>
					<div class="post-entry">
						<div class="entry-content">
							<?php echo $cur_post['message']."\n" ?>
<?php if ($cur_post['edited'] != ''): ?>							<p class="lastedit"><?php printf($lang_topic['Last edited by'], htmlspecialchars($cur_post['edited_by'])) ?> (<abbr class="updated" title="<?php echo date("Y-m-d\Th:i:s\Z", $cur_post['edited']) ?>"><?php echo format_time($cur_post['edited']) ?></abbr>)</p>
<?php endif; ?>						</div>
					</div>
<?php if ($signature != ''): ?>					<div class="post-sig">
						<div class="sig-content"><span class="sig-line"><!-- --></span><?php echo $signature ?></div>
					</div>
<?php endif; ?>				</div>
			</div>
			<div class="postfoot">
				<ul>
					<?php echo implode("\n\t\t\t\t\t", $post_options)."\n" ?>
				</ul>
			</div>
		</div>
<?php

}

// Display topic options
$main_options[] = '<li id="mo-rss" class="mo-users"><a href="'.pun_link($pun_url['topic_rss'], $id).'">'.$lang_common['RSS Feed'].'</a></li>';
$main_options[] = '<li id="mo-atom" class="mo-users"><a href="'.pun_link($pun_url['topic_atom'], $id).'">'.$lang_common['ATOM Feed'].'</a></li>';

if (!$pun_user['is_guest'] && $pun_config['o_subscriptions'] == '1')
{
	if ($cur_topic['is_subscribed'])
		$main_options[] = '<li id="mo-sub" class="mo-users"><a title="'.$lang_topic['Unsubscribe info'].'" href="'.pun_link($pun_url['unsubscribe'], $id).'">'.$lang_topic['Unsubscribe'].'</a></li>';
	else
		$main_options[] = '<li id="mo-unsub" class="mo-users"><a title="'.$lang_topic['Subscribe info'].'" href="'.pun_link($pun_url['subscribe'], $id).'">'.$lang_topic['Subscribe'].'</a></li>';
}

if ($is_admmod)
{
	$main_options[] = '<li id="mo-move" class="mo-mods"><a href="'.pun_link($pun_url['move'], array($cur_topic['forum_id'],$id)).'">'.$lang_topic['Move'].'</a></li>';
	$main_options[] = ($cur_topic['closed'] == '1') ? '<li id="mo-open" class="mo-mods"><a href="'.pun_link($pun_url['open'], array($cur_topic['forum_id'],$id)).'">'.$lang_topic['Open'].'</a></li>' : '<li id="mo-close" class="mo-mods"><a href="'.pun_link($pun_url['close'],array($cur_topic['forum_id'],$id)).'">'.$lang_topic['Close'].'</a></li>';
	$main_options[] = ($cur_topic['sticky'] == '1') ? '<li id="mo-unstick" class="mo-mods"><a href="'.pun_link($pun_url['unstick'], array($cur_topic['forum_id'],$id)).'">'.$lang_topic['Unstick'].'</a></li>' : '<li id="mo-stick" class="mo-mods"><a href="'.pun_link($pun_url['stick'],array($cur_topic['forum_id'],$id)).'">'.$lang_topic['Stick'].'</a></li>';

	if ($cur_topic['num_replies'] != 0)
	{
		$main_options[] = '<li id="mo-delete" class="mo-mods"><a href="'.pun_sublink($pun_url['delete_multiple'], $pun_url['page'], $p, array($cur_topic['forum_id'], $id)).'">'.$lang_topic['Delete posts'].'</a></li>';
		if ($cur_topic['approval'] == 1)
			$main_options[] = '<li id="mo-approve" class="mo-mods"><a href="'.pun_sublink($pun_url['approve_multiple'], $pun_url['page'], $p, array($cur_topic['forum_id'], $id)).'">'.$lang_topic['Approve posts'].'</a></li>';
	}
}

?>
	</div>

	<div class="b-section b-mainoptions">
		<div class="c-section c-any">
			<h2 class="prefix"><span><?php echo $lang_topic['Topic options'] ?></span></h2>
			<ul class="optionlist">
				<?php echo implode("\n\t\t\t\t", $main_options)."\n" ?>
			</ul>
		</div>
	</div>

	<div class="main-foot">
		<?php echo $main_links."\n" ?>
	</div>

</div>

<?php


// Display quick post if enabled
if ($pun_config['o_quickpost'] == '1' &&
	!$pun_user['is_guest'] &&
	($cur_topic['post_replies'] == '1' || ($cur_topic['post_replies'] == '' && $pun_user['g_post_replies'] == '1')) &&
	($cur_topic['closed'] == '0' || $is_admmod))
{

?>
<div id="pun-main2" class="a-section a-main">

	<h2 class="main-title"><span><?php echo $lang_topic['Quick post'] ?></span></h2>

	<div class="b-section b-postform">
		<div class="c-section c-form">
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['new_reply'], $id) ?>">
			<div class="panel">
<?php

if ($pun_user['is_admmod'])
	echo "\t\t\t\t".'<input type="hidden" name="csrf_token" value="'.$pun_user['csrf_token'].'" />'."\n";
if (!$pun_user['is_guest'] && $pun_config['o_subscriptions'] == '1' && ($pun_user['auto_notify'] == '1' || $cur_topic['is_subscribed']))
	echo "\t\t\t\t".'<input type="hidden" name="subscribe" value="1" />'."\n";

$post_help = array();

if ($pun_config['p_message_bbcode'] == '1') $post_help[] = '<li><a href="'.pun_link($pun_url['help'], 'bbcode').'" onclick="window.open(this.href); return false;" title="'.$lang_common['New window warn'].'">'.$lang_common['BBCode help'].'</a></li>';
if ($pun_config['p_message_img_tag'] == '1') $post_help[] = '<li><a href="'.pun_link($pun_url['help'], 'img').'" onclick="window.open(this.href); return false;" title="'.$lang_common['New window warn'].'">'.$lang_common['img tag help'].'</a></li>';
if ($pun_config['o_smilies'] == '1') $post_help[] = '<li><a href="'.pun_link($pun_url['help'], 'smilies').'" onclick="window.open(this.href); return false;" title="'.$lang_common['New window warn'].'">'.$lang_common['Smilies help'].'</a></li>';

if (!empty($post_help))
{

?>
				<div class="form-intro">
					<ul class="optionlist">
						<?php echo implode("\n\t\t\t\t\t\t", $post_help)."\n" ?>
					</ul>
				</div>
<?php

}

?>
				<p id="req-msg" class="req-warn"><?php printf($lang_common['Required warn'], '<em class="req-text">'.$lang_common['Required mark'].'<span> '.$lang_common['Required'].'</span></em>') ?></p>
				<fieldset id="fs1">
					<legend><span><?php echo $lang_common['Write message legend'] ?></span></legend>
					<input type="hidden" name="form_sent" value="1" />
					<input type="hidden" name="form_user" value="<?php echo (!$pun_user['is_guest']) ? htmlspecialchars($pun_user['username']) : 'Guest'; ?>" />
					<p class="areafield required">
						<label for="fs1f1"><?php echo $lang_common['Message'] ?>  <em class="req-text"><?php echo $lang_common['Required mark'].' <span>'.$lang_common['Required'].'</span>' ?></em></label><br />
						<span class="input"><textarea id="fs1f1" name="req_message" rows="7" cols="95"></textarea></span>
					</p>
				</fieldset>
<?php

if (!$is_admmod && $pun_user['g_posts_approved'] == 0 && $cur_topic['approval'] == 1)
{

?>
				<div class="form-warn">
					<p><strong><?php echo $lang_common['Warning'] ?></strong> <?php echo $lang_common['Approval warning'] ?></p>
				</div>
<?php

}

?>
				<p class="formsubmit"><input type="submit" class="button" name="submit" value="<?php echo $lang_common['Submit'] ?>" accesskey="s" title="<?php echo $lang_common['Submit title'] ?>" /></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php

}

// Increment "num_views" for topic
if ($pun_config['o_topic_views'] == '1')
{
	$low_prio = ($db_type == 'mysql' || $db_type == 'mysqli') ? 'LOW_PRIORITY ' : '';
	$db->query('UPDATE '.$low_prio.$db->prefix.'topics SET num_views=num_views+1 WHERE id='.$id) or error('Unable to update topic', __FILE__, __LINE__, $db->error());
}

$forum_id = $cur_topic['forum_id'];
require PUN_ROOT.'footer.php';
